package com.gct.edge;

import lombok.extern.slf4j.Slf4j;
import org.mybatis.spring.annotation.MapperScan;
import org.springframework.boot.SpringApplication;
import org.springframework.boot.autoconfigure.SpringBootApplication;

import java.io.IOException;

@SpringBootApplication
@MapperScan("com.gct.edge.mapper*")
@Slf4j
public class EdgeCalculateApplication {

    public static void init(){
        try {
            Runtime.getRuntime().exec("bash ./shell/dbm.sh init");
            Runtime.getRuntime().exec("bash ./shell.dbm.sh load");
            Thread.sleep(2000);
            log.info("Database checked,it's available.");
        } catch (Exception e) {
            log.info("Database check failed");
            System.exit(-1);
        }

    }

    public static void main(String[] args) {
        init();
        SpringApplication.run(EdgeCalculateApplication.class, args);
    }

}

