package com.gct.edge.quartztask;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.gct.edge.entity.AoidSinglegtYield;
import com.gct.edge.entity.DgnsGtbaseparam;
import com.gct.edge.entity.DgnsGtcvrresult;
import com.gct.edge.service.abst.AoidSinglegtYieldService;
import com.gct.edge.service.abst.DgnsGtbaseparamService;
import com.gct.edge.service.abst.DgnsGtcvrresultService;
import org.quartz.JobExecutionContext;
import org.quartz.JobExecutionException;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.quartz.QuartzJobBean;
import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;

/**
 * @author xusirui 2024/4/17
 */
public class MemoryMaintenanceTask extends QuartzJobBean {

    @Autowired
    DgnsGtbaseparamService dgnsGtbaseparamService;

    @Autowired
    DgnsGtcvrresultService dgnsGtcvrresultService;

    @Autowired
    AoidSinglegtYieldService aoidSinglegtYieldService;

    @Override
    protected void executeInternal(JobExecutionContext context) throws JobExecutionException {
        String dateYesterday = LocalDateTime.now().minusDays(3).format(DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss"));

        dgnsGtbaseparamService.remove(new QueryWrapper<DgnsGtbaseparam>()
                .last(String.format("where datetime(recivetime) < datetime('%s')",dateYesterday)));
        dgnsGtcvrresultService.remove(new QueryWrapper<DgnsGtcvrresult>()
                .last(String.format("where datetime(createtime) < datetime('%s')",dateYesterday)));
        aoidSinglegtYieldService.remove(new QueryWrapper<AoidSinglegtYield>()
                .last(String.format("where datetime(prod_date) < datetime('%s')",dateYesterday)));
    }
}
