package com.gct.edge.service.excutor;

import com.gct.edge.zdly.aoid.core.CalculateProductionService;
import com.gct.edge.zdly.dgns.core.*;
import com.gct.edge.entity.CalculateInputData;
import com.gct.edge.entity.DgnsGtcvrresult;
import com.gct.edge.entity.DgnsGtstandard;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

/**
 * @author xusirui 2024/3/7
 */
@Service
public class CalculateService {

    @Autowired
    GenerateResult generateResult;

    @Autowired
    GtAnalysis gtAnalysis;

    @Autowired
    FirstDiagnose firstDiagnose;

    @Autowired
    SecondDiagnose secondDiagnose;

    @Autowired
    ThirdDiagnose thirdDiagnose;

    @Autowired
    CalculateProductionService calculateProductionService;

    public void diagnoseAndCalculateLiquid(CalculateInputData inputData){
        DiagnoseVisitor diagnoseVisitor = new DiagnoseVisitor() {
            {
                logBuilder = new StringBuilder();
                calculateInputData = inputData;
                cvResult = new DgnsGtcvrresult();
                standardGt = new DgnsGtstandard();
            }
        };
        gtAnalysis.accept(diagnoseVisitor);
        firstDiagnose.accept(diagnoseVisitor);
        secondDiagnose.accept(diagnoseVisitor);
        thirdDiagnose.accept(diagnoseVisitor);
        generateResult.accept(diagnoseVisitor);

        //calculate production
        calculateProductionService.calculateProductionEntrance(diagnoseVisitor);
    }
}
