package com.gct.edge.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.gct.common.util.SGTUtil;
import com.gct.edge.zdly.dgns.algo.CalGtSimilar;
import com.gct.edge.entity.DgnsGtbaseparam;
import com.gct.edge.entity.DgnsGtstandard;
import com.gct.edge.mapper.DgnsGtstandardMapper;
import com.gct.edge.service.abst.DgnsGtstandardService;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;

import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.List;

/**
 * <p>
 *  服务实现类
 * </p>
 *
 * @author xsr
 * @since 2024-03-07
 */
@Service
public class DgnsGtstandardServiceImpl extends ServiceImpl<DgnsGtstandardMapper, DgnsGtstandard> implements DgnsGtstandardService {

    @Override
    public List<DgnsGtstandard> getAllStandGt(String wellId) {
        return baseMapper.selectList(new QueryWrapper<DgnsGtstandard>().eq("wellname",wellId));
    }

    @Override
    public void calStdGt(DgnsGtbaseparam baseparam,String cvResult1) {
        final DateTimeFormatter df = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");

        List<DgnsGtstandard> allStandGt = getAllStandGt(baseparam.getWellname());
        DgnsGtstandard preStdGt = new DgnsGtstandard();
        preStdGt.setSgtprodate(baseparam.getRecivetime());
        preStdGt.setWellname(baseparam.getWellname());
        preStdGt.setFuture(CalGtSimilar.encodeToString(new CalGtSimilar().tryCalGray(SGTUtil.encodeToUseList(baseparam.getSgt()))));
        if (preStdGt.getFuture().isEmpty())return;
        preStdGt.setAppearcounter(1);
        preStdGt.setMaxsemblance(0d);
        preStdGt.setMinsemblance(100d);
        preStdGt.setGraphicfeatureinterpretation(cvResult1);

        if (allStandGt.isEmpty()){
            preStdGt.setCreatetime(LocalDateTime.now().format(df));
            baseMapper.insert(preStdGt);
            return;
        }
        for (DgnsGtstandard gtstandard : allStandGt) {
            Double graySimilar = CalGtSimilar.compareCharacters(CalGtSimilar.encodeToList(gtstandard.getFuture())
                    , CalGtSimilar.encodeToList(preStdGt.getFuture()), 23);
            if (graySimilar>=0.95){
                if (graySimilar*100<gtstandard.getMinsemblance())gtstandard.setMinsemblance(graySimilar*100);
                if (graySimilar*100>gtstandard.getMaxsemblance())gtstandard.setMaxsemblance(graySimilar*100);
                gtstandard.setAppearcounter(preStdGt.getAppearcounter()+1);
                gtstandard.setSgtprodate(preStdGt.getSgtprodate());
                gtstandard.setLatestupdatedtime(preStdGt.getLatestupdatedtime());
                baseMapper.update(gtstandard,new QueryWrapper<DgnsGtstandard>().eq("id",gtstandard.getId()));
                return;
            }
        }
        //if not update, delete one oldest if exceed then add a new std gt
        DgnsGtstandard deleteStd = allStandGt.stream().min((x, y) -> {
            LocalDateTime xDate = LocalDateTime.parse(x.getSgtprodate(), df);
            LocalDateTime yDate = LocalDateTime.parse(y.getSgtprodate(), df);
            return xDate.compareTo(yDate);
        }).get();
        baseMapper.delete(new QueryWrapper<DgnsGtstandard>().eq("id",deleteStd.getId()));
        preStdGt.setLatestupdatedtime(LocalDateTime.now().format(df));
        baseMapper.insert(preStdGt);
    }
}
