package com.gct.edge.zdly.aoid.entity;

import com.alibaba.fastjson.JSONObject;
import com.gct.common.util.SGTUtil;
import com.gct.edge.entity.AoidRodsModule;
import com.gct.edge.entity.DgnsGtbaseparam;
import com.gct.edge.zdly.aoid.core.GlobalDataManager;
import lombok.Data;

import java.util.ArrayList;
import java.util.List;

public class ProductionCoreData {

    GlobalDataManager globalDataManager;

    public ProductionCoreData(GlobalDataManager globalDataManager) {
        this.globalDataManager = globalDataManager;
    }


    @Data
    public class pumpCard {
        List<Double> right_up_point;
        List<Double> left_down_point;
        int right_up_point_index;
        int left_down_point_index;
        int total_point;
        //        double down_load_level;
//        double up_load_level;
        double max_load;
        double min_load;
        double min_stroke;
        double max_stroke;
        List<List<Double>> dbu = new ArrayList<>();

        boolean checkCard(List<List<Double>> sgt, boolean reverse) {
            int K = sgt.size();
            if (K <= 0) return false;
            total_point = K;
            dbu.clear();
//    dbu = sgt;
//    return false;
            double down = 0, up = 0;

            for (int i = 0; i < K / 2; ++i) {
                down += sgt.get(K - i - 1).get(1);
                up += sgt.get(i).get(1);
            }
            if (up < down) {//功图反转了 修正

                for (int i = 0; i < K; ++i) {
                    List<Double> p = new ArrayList<>();
                    p.add(sgt.get(K - i - 1).get(0));
                    p.add(sgt.get(K - i - 1).get(1));
                    dbu.add(p);
                }
            } else {
                for (int i = 0; i < K; ++i) {
                    List<Double> p = new ArrayList<>();
                    p.add(sgt.get(i).get(0));
                    p.add(sgt.get(i).get(1));
                    dbu.add(p);
                }
            }
            min_load = dbu.get(0).get(1);
            max_load = dbu.get(0).get(1);
            max_stroke = dbu.get(0).get(0);
            min_stroke = dbu.get(0).get(0);
            right_up_point_index = 0;
            left_down_point_index = 0;
            left_down_point = dbu.get(0);
            right_up_point = dbu.get(0);
            for (int i = 1; i < K; ++i) {
                if (dbu.get(i).get(1) > max_load) max_load = dbu.get(i).get(1);
                if (dbu.get(i).get(1) < min_load) min_load = dbu.get(i).get(1);
                if (dbu.get(i).get(0) > max_stroke) max_stroke = dbu.get(i).get(0);
                if (dbu.get(i).get(0) < min_stroke) min_stroke = dbu.get(i).get(0);
            }

            for (int i = 0; i < K; ++i) {//计算液体载荷
                dbu.get(i).set(1, dbu.get(i).get(1) - min_load + (min_load + max_load) * 0.1);// min_load;
                dbu.get(i).set(0, dbu.get(i).get(0) - min_stroke);
            }
            return true;
        }
    }

    public class GtRevision {

        String sgt;
        String sgtx;
        double cha;
        String result = "";
        double[][] cardArray;
        double[][] card;
        double cc1;
        double maxLoad;
        double minLoad;
        double maxShift;
        double minShift;
        int pointNum;
        double loadmin;
        int minShiftPoint;
        int maxShiftPoint;
        double maxShiftLoad;
        double minShiftLoad;

        public void sgt_encode(DgnsGtbaseparam dgnsGtbaseparam) {
            result = "功图错误或仪器故障";
            pointNum = dgnsGtbaseparam.getSgtpointnum();
            if (pointNum % 2 != 0) pointNum--;

            if (pointNum <= 0 || dgnsGtbaseparam.getSgt().isEmpty()) {
                return;
            }
            double[][] sgt = SGTUtil.encodeToUseArray(dgnsGtbaseparam.getSgt());
            minLoad = Double.parseDouble(dgnsGtbaseparam.getLMin());
            maxLoad = Double.parseDouble(dgnsGtbaseparam.getLMax());
            minShiftPoint = dgnsGtbaseparam.getSMinPointLocation();
            minShift = Double.parseDouble(dgnsGtbaseparam.getSMin());
            minShiftLoad = sgt[minShiftPoint][1];
            maxShift = Double.parseDouble(dgnsGtbaseparam.getSMax());
            maxShiftPoint = dgnsGtbaseparam.getSMaxPointLocation();
            maxShiftLoad = sgt[maxShiftPoint][1];
            cha = Double.parseDouble(dgnsGtbaseparam.getS());
            cc1 = relu_compute(Double.parseDouble(dgnsGtbaseparam.getN()));

            card = new double[2][];
            card[0] = new double[pointNum];
            card[1] = new double[pointNum];
            for (int i = 0; i < pointNum; ++i) {
                card[0][i] = sgt[i][0];
                card[1][i] = sgt[i][1];
            }
            cardArray = new double[2][];
            cardArray[0] = new double[pointNum];
            cardArray[1] = new double[pointNum];
            for (int j = 0; j < pointNum; j++) {
                if (minShiftPoint + j < pointNum) {
                    cardArray[0][j] = card[0][minShiftPoint + j];
                    cardArray[1][j] = card[1][minShiftPoint + j];
                } else {
                    cardArray[0][j] = card[0][minShiftPoint + j - pointNum];
                    cardArray[1][j] = card[1][minShiftPoint + j - pointNum];
                }
            }

            //功图界值的判断，可以考虑不要，前面已经判断了功图合法性
    /*if (maxLoad == minLoad || minLoad > 150 || maxLoad > 150 || minLoad < 0 || maxLoad < 0 || pointNum < 60 ||
        pointNum % 2 != 0 || cha < -8)*/
            if (dgnsGtbaseparam.getIslegal() != 1)
                result = "功图错误或仪器故障";
            else result = "";
        }

        double relu_compute(double t) {
            if (t < globalDataManager.getGlobalData("relu-allowed-x-min", Integer.class))
                return globalDataManager.getGlobalData("relu-min-default", Integer.class);
            if (t > globalDataManager.getGlobalData("relu-allowed-x-max", Integer.class))
                return globalDataManager.getGlobalData("relu-max-default", Integer.class);
            return t;
        }
    }

    public class calbgt {

        AoidRodsModule aoidRodsModule;

        public calbgt(AoidRodsModule aoidRodsModule) {
            this.aoidRodsModule = aoidRodsModule;
        }


        double maxShift = -100000;
        double minShift = 10000;
        double maxLoad = -100000;
        double minLoad = 100000;
        String cha;
        String _maxShift;
        String _minShift;
        String _maxLoad;
        String _minLoad;
        double cc;
        double cc1;
        int pointNum;
        double[][] card;
        double[][] cardSlope;
        double[][] cardMakeUp;
        double znxs;
        double theorycc;
        double power;
        double yxcc;
        double makeUpPower;
        String result;
        GtRevision _encode;
        String bgtstr = "";
        public List<List<Double>> bgt = new ArrayList<>();
        int calnumb = 0;

        public void cal_bgt(GtRevision gtRevision, String zdjg) {
            double tmpDownLevel = 0.001;
            double tmpUpLevel = 0, downLoadingLevel = 0, upLoadingLevel = 0;
            int tmpANNNum = 0;
            if (!gtRevision.result.isEmpty()) return;

            while (tmpANNNum == 0) {
                for (int i = 0; i < gtRevision.pointNum / 2; i++) {
                    if (gtRevision.cardArray[0][i] <= gtRevision.cha * tmpDownLevel) {
                        tmpANNNum++;
                        downLoadingLevel += gtRevision.cardArray[1][i];
                    }
                }
                tmpDownLevel += 0.001;
            }
            downLoadingLevel = downLoadingLevel / tmpANNNum;
            tmpANNNum = 0;
            tmpUpLevel = 0.98;
            while (tmpANNNum == 0) {
                for (int i = 0; i < gtRevision.pointNum; i++) {
                    if (gtRevision.cardArray[0][i] >= gtRevision.cha * tmpUpLevel) {
                        tmpANNNum++;
                        upLoadingLevel = upLoadingLevel + gtRevision.cardArray[1][i];
                    }
                }
                tmpUpLevel = tmpUpLevel - 0.001;
            }
            upLoadingLevel /= tmpANNNum;
            double tmpdDMWY[] = new double[gtRevision.pointNum];
            double tmpdDMYeZH[] = new double[gtRevision.pointNum];
//    double DBU[2][gtRevision.pointNum];
            List<List<Double>> DBU = new ArrayList<>();//[2][gtRevision.pointNum];
            double equivalRodDiameter;
            for (int i = 0; i < gtRevision.pointNum; i++) {
                tmpdDMWY[i] = gtRevision.cardArray[0][i];
                tmpdDMYeZH[i] = gtRevision.cardArray[1][i];
                tmpdDMYeZH[i] = tmpdDMYeZH[i] * 1000 - downLoadingLevel * 1000;
            }
            double pumpdepth;
            equivalRodDiameter = 0.035;//等效杆直径
            pumpdepth = (downLoadingLevel / 9.8 * 4 / Math.PI / 7.85) / (equivalRodDiameter * equivalRodDiameter);
            pumpdepth = 50;//???


            boolean p_pc = zdjg.contains("喷抽");
            //Dbu[1][0]  Dbu[0][TotalPoint + 2]  Dbu[0][TotalPoint + 1]  Dbu[1][TotalPoint + 1]  Dbu[0][0]
            double dzxwyzh = 0, dzxwy = 0, dbmaxload = 0, dbminload = 0, ddZNXShC = 0;
            do {
                do {
                    equivalRodDiameter = Math.sqrt(downLoadingLevel / 9.8 * 4 / Math.PI / 7.85 / pumpdepth);
                    pumpdepth = pumpdepth + 20;
                } while (equivalRodDiameter >= 0.055);
                //pumpdepth = pumpdepth - 20;
                calnumb++;

                DBU = subGeJiGanGT(-pumpdepth, equivalRodDiameter, 7850, 210000000000l, tmpdDMWY, tmpdDMYeZH,
                        gtRevision.cc1, gtRevision.pointNum, gtRevision.pointNum / 2, 10, 0.022,
                        0.062, dzxwyzh, dzxwy, dbmaxload, dbminload, ddZNXShC);

                double upload = 0;
                double download = 0;
                for (int i = 0; i < gtRevision.pointNum / 2; i++) {
                    upload = DBU.get(1).get(i) + upload;
                    download = DBU.get(1).get(gtRevision.pointNum / 2 + i) + download;
                }
                if (upload < download) {//功图反转校验
                    for (int i = 0; i < gtRevision.pointNum / 2; i++) {
                        int downloadindex = gtRevision.pointNum - i - 1;
                        double tempstroke = DBU.get(0).get(i);
                        double tempload = DBU.get(1).get(i);
                        DBU.get(0).set(i, DBU.get(0).get(downloadindex));
                        DBU.get(1).set(i, DBU.get(1).get(downloadindex));
                        DBU.get(0).set(downloadindex, tempstroke);
                        DBU.get(1).set(downloadindex, tempload);
                    }
                }
                if (p_pc) {
                    break;
                }
                if (pumpdepth < 1800) {
                    pumpdepth += 20;
                } else break;
            } while (dzxwyzh < (dbmaxload + dbminload) * 3.5 / 8);
            {
                card = new double[2][];
                card[0] = new double[gtRevision.pointNum];
                card[1] = new double[gtRevision.pointNum];
            }
            bgt.clear();
            for (int i = 0; i < gtRevision.pointNum; i++) {
                card[0][i] = DBU.get(0).get(i);
                card[1][i] = DBU.get(1).get(i) / 1000;
                if (DBU.get(1).get(i) / 1000 > maxLoad)
                    maxLoad = DBU.get(1).get(i) / 1000;
                if (DBU.get(1).get(i) / 1000 < minLoad)
                    minLoad = DBU.get(1).get(i) / 1000;
                if (DBU.get(0).get(i) > maxShift)
                    maxShift = DBU.get(0).get(i);
                if (DBU.get(0).get(i) < minShift)
                    minShift = DBU.get(0).get(i);

                int x = (int) Math.floor(DBU.get(0).get(i) * 100);
                int y = (int) Math.floor(DBU.get(1).get(i) / 10);

                bgtstr = bgtstr + String.format("%03d%05d", x, y);
                List<Double> p = new ArrayList<>();

                p.add(DBU.get(0).get(i));
                p.add(DBU.get(1).get(i) / 1000);//kN
                bgt.add(p);
            }
            _maxShift = Double.toString(maxShift);
            _minShift = Double.toString(minShift);
            _maxLoad = Double.toString(maxShift);
            _minLoad = Double.toString(minLoad);
            _maxShift = _maxShift.substring(0, 2) + "." + _maxShift.substring(2, 4);
            _minShift = _minShift.substring(0, 2) + "." + _minShift.substring(2, 4);
            _maxLoad = _maxLoad.substring(0, 3) + "." + _maxLoad.substring(3, 5);
            _maxLoad = _minLoad.substring(0, 3) + "." + _minShift.substring(3, 5);
            cha = Double.toString(maxShift - minShift);
            cha = cha.substring(0, 3) + "." + cha.substring(3, 5);
        }


        int p;

        double dFunXShXiGeMa_n(double dWuMiGa, double DT, int iCShn, double[] dZaiHe, int iDianShu) {
            double dFunXShXiGeMa = 0;
            for (int i = 0; i < iDianShu; i++) {
                dFunXShXiGeMa = dFunXShXiGeMa + dZaiHe[i] * Math.cos(iCShn * dWuMiGa * i * DT) * DT;
            }
            return dFunXShXiGeMa * dWuMiGa / Math.PI;
        }

        double dFunXShTao_n(double dWuMiGa, double DT, int iCShn, double[] dZaiHe, int iDianShu) {
            double dFunXShTao = 0;
            for (int i = 0; i < iDianShu; i++) {
                dFunXShTao = dFunXShTao + dZaiHe[i] * Math.sin(iCShn * dWuMiGa * i * DT) * DT;
            }
            return dFunXShTao * dWuMiGa / Math.PI;
        }

        double dFunXShMiu_n(double dWuMiGa, double DT, int iCShn, double[] dWeiYi, int iDianShu) {
            double dFunXShMiu_n = 0;
            for (int i = 0; i < iDianShu; i++) {
                dFunXShMiu_n = dFunXShMiu_n + dWeiYi[i] * Math.cos(iCShn * dWuMiGa * i * DT) * DT;
            }
            //double temp = dFunXShMiu_n;
            return dFunXShMiu_n * dWuMiGa / Math.PI;
        }

        double dFunXShDeErTa_n(double dWuMiGa, double DT, int iCShn, double[] dWeiYi, int iDianShu) {
            double dFunXShDeErTa_n = 0;
            for (int i = 0; i < iDianShu; i++) {
                dFunXShDeErTa_n = dFunXShDeErTa_n + dWeiYi[i] * Math.sin(iCShn * dWuMiGa * i * DT) * DT;
            }
            return dFunXShDeErTa_n * dWuMiGa / Math.PI;
        }

        double dFunFLYZaiHe(double dWuMiGa, int iCShn, double[] dXiGeMa, double[] dTao, double dShiJian_t) {
            double dFunFLYZaiHe = dXiGeMa[0] / 2;
            for (int i = 1; i < iCShn; i++) {
                dFunFLYZaiHe = dFunFLYZaiHe + dXiGeMa[i] * Math.cos(i * dWuMiGa * dShiJian_t) +
                        dTao[i] * Math.sin(i * dWuMiGa * dShiJian_t);
            }
            return dFunFLYZaiHe;
        }

        double dFunYWeiYi(double dWuMiGa, int iCShn, double[] dMiu, double[] dDeErTa, double dShiJian_t) {
            double dFunFLYWeiYi = dMiu[0] / 2;
            for (int i = 1; i < iCShn; i++) {
                dFunFLYWeiYi = dFunFLYWeiYi + dMiu[i] * Math.cos(i * dWuMiGa * dShiJian_t) +
                        dDeErTa[i] * Math.sin(i * dWuMiGa * dShiJian_t);
            }
            return dFunFLYWeiYi;
        }

        double dFunSH(double dz) {
            return (Math.exp(dz) - Math.exp(-dz)) * 0.5;
        }

        double dFunCH(double dz) {
            return (Math.exp(dz) - Math.exp(-dz)) * 0.5;
        }

        double dFunXSha_n(double dWuMiGa, int iCShn, double dCShC, double dCSHa) {
            iCShn++;
            double te =
                    iCShn * dWuMiGa / dCSHa / Math.sqrt(2) * Math.sqrt(1 + Math.sqrt(1 + Math.pow(dCShC / iCShn / dWuMiGa, 2)));
            return te;
        }

        double dFunXShB_n(double dWuMiGa, int iCShn, double dCShC, double dCSHa) {
            iCShn++;
            return iCShn * dWuMiGa / dCSHa / Math.sqrt(2) * Math.sqrt(-1 + Math.sqrt(1 + Math.pow(dCShC / iCShn / dWuMiGa, 2)));
        }

        double dFunXShK_n(double dan, double dBn, double DXiGeMa, double dTaon, double dE, double dAr) {
            return (DXiGeMa * dan + DXiGeMa * dBn) / (dE * dAr * (Math.pow(dan, 2) + Math.pow(dBn, 2)));
        }

        double dFunXShU_n(double dan, double dBn, double DXiGeMan, double dTaon, double dE, double dAr) {
            return (DXiGeMan * dBn - dTaon * dan) / (dE * dAr * (Math.pow(dan, 2) + Math.pow(dBn, 2)));
        }

        double
        dFunZLXShC(double dWuMiGa, double dCSHa, double dCSh_u, double dRor, double dAr, double dDt, double dDr,
                   double dL) {
            double tmpm, tmpQXSh, tmpFM;
            double tmpB1, tmpB2;
            tmpm = dDt / dDr;
            tmpFM = dWuMiGa * dL / (dCSHa * Math.sin(dWuMiGa * dL / dCSHa)) + Math.cos(dWuMiGa * dL / dCSHa);
            tmpFM = 2 / tmpFM;
            tmpB1 = (tmpm * tmpm - 1) / (2 * Math.log(tmpm)) - 1;
            tmpB2 = Math.pow(tmpm, 4) - 1 - Math.pow((tmpm * tmpm - 1), 2) / Math.log(tmpm);
            tmpQXSh = 2 * Math.PI * dCSh_u / dRor / dAr;
            //double t = Math.log(tmpm);
            double temp = tmpQXSh * (1 / Math.log(tmpm) + 4 * (tmpB1 + 1) / tmpB2 * (tmpB1 + tmpFM));
            return temp;
        }

        double dFunO_n(double dx, double dKn, double dBn, double dDeErTan, double dan, double dUn, double dMiun) {
            double t = (dKn * dFunCH(dBn * dx) + dDeErTan * dFunSH(dBn * dx)) * Math.sin(dan * dx) +
                    (dUn * dFunSH(dBn * dx) + dMiun * dFunCH(dBn * dx)) * Math.cos(dan * dx);
            return t;
        }

        double dFunP_n(double dx, double dKn, double dBn, double dDeErTan, double dan, double dUn, double dMiun) {
            double t = (dKn * dFunSH(dBn * dx) + dDeErTan * dFunCH(dBn * dx)) * Math.cos(dan * dx) -
                    (dUn * dFunCH(dBn * dx) + dMiun * dFunSH(dBn * dx)) * Math.sin(dan * dx);
            return t;
        }

        double
        dFunPianO_n(double dx, double dKn, double dBn, double dDeErTan, double dan, double dUn, double dMiun,
                    double dTaon,
                    double DXiGeMan, double dE, double dAr) {
            double t = (dTaon / (dE * dAr) * dFunSH(dBn * dx) + (dDeErTan * dBn - dan * dMiun) * dFunCH(dBn * dx)) *
                    Math.sin(dan * dx) +
                    (DXiGeMan / (dE * dAr) * dFunCH(dBn * dx) + (dDeErTan * dan + dBn * dMiun) * dFunSH(dBn * dx)) *
                            Math.cos(dan * dx);
            return t;
        }

        double
        dFunPianP_n(double dx, double dKn, double dBn, double dDeErTan, double dan, double dUn, double dMiun,
                    double dTaon,
                    double DXiGeMan, double dE, double dAr) {
            return (dTaon / (dE * dAr) * dFunCH(dBn * dx) + (dDeErTan * dBn - dan * dMiun) * dFunSH(dBn * dx)) *
                    Math.cos(dan * dx) -
                    (DXiGeMan / (dE * dAr) * dFunSH(dBn * dx) + (dDeErTan * dan + dBn * dMiun) * dFunCH(dBn * dx)) *
                            Math.sin(dan * dx);
        }

        double
        dFunUxt(double dx, double dWuMiGa, double dXiGeMa0, double dMiu0, double dE, double dAr, int iCShn, double[] dOn,
                double[] dPn, double dShiJian_t) {
            double dFunUxt = dXiGeMa0 / (2 * dE * dAr) * dx + dMiu0 / 2;
            for (int i = 1; i < iCShn; i++) {
                dFunUxt = dFunUxt + dOn[i] * Math.cos(i * dWuMiGa * dShiJian_t) + dPn[i] * Math.sin(i * dWuMiGa * dShiJian_t);
            }
            return dFunUxt;
        }

        double
        dFunFxt(double dWuMiGa, double dXiGeMa0, double dE, double dAr, int iCShn, double[] dPianOn, double[] dPianPn,
                double dShiJian_t) {
            double dFunFxt = 0;
            for (int i = 1; i < iCShn; i++) {
                dFunFxt = dFunFxt + dPianOn[i] * Math.cos(i * dWuMiGa * dShiJian_t) +
                        dPianPn[i] * Math.sin(i * dWuMiGa * dShiJian_t);
            }
            dFunFxt = dFunFxt + dXiGeMa0 / (2 * dE * dAr);
            double t = dE * dAr * dFunFxt;
            return t;
        }

        final static int p_num = 12;
        final static int alpha_n = 0;
        final static int beta_n = 1;
        final static int sigma_n = 2;
        final static int tau_n = 3;
        final static int nu_n = 4;
        final static int delta_n = 5;
        final static int kappa_n = 6;
        final static int mu_n = 7;
        final static int O_n = 8;
        final static int P_n = 9;
        final static int O_n_2 = 10;
        final static int P_n_2 = 11;


        void init_matrix(int n, List<List<Double>> matrix) {
            for (int i = 0; i < p_num; ++i) {
                List<Double> m = new ArrayList<>();
                for (int j = 0; j < n; ++j) {
                    m.add(0d);
                }
                matrix.add(m);
            }
        }

        List<List<Double>>
        subGeJiGanGT(double dNowGanSh, double dGanJing, double GanMidu, double DXML_E, double[] DdiMianWY,
                     double[] dYeZhong,
                     double chongci, int TotalPoint, int UpPoint, int iNN1, double Viscosity, double Tubingsize,
                     double dzxwyzh, double dzxwy, double dbmaxload, double dbminload, double ddZNXShC) {
            int iNN = iNN1;
            double[] dXShXiGeMa = new double[iNN];
            double[] dXShTao = new double[iNN];
            double[] dXShMiu = new double[iNN];
            double[] dXShDeErTa = new double[iNN];
            double[] dXSha = new double[iNN];
            double[] dXShB = new double[iNN];
            double[] dXShK = new double[iNN];
            double[] dXSHU = new double[iNN];
            List<List<Double>> Dbu = new ArrayList<>();
    /*double **Dbu = new double *[2];
    Dbu[0] = new double[TotalPoint + 3];
    Dbu[1] = new double[TotalPoint + 3];*/
            double[] dbengu = new double[TotalPoint];
            double bmaxload = 0;
            double bminload = 0;
            double[] dbengf = new double[TotalPoint];
            double[] dZhJZhO = new double[iNN];
            double[] dZhJZhP = new double[iNN];
            double[] dZhJZhPianO = new double[iNN];
            double[] dZhJZhPianP = new double[iNN];
            double dZNXShC;
            double tmpdZuNiCup;
            double tmpdZuNiCdown;
            double MinshiftPoint = 1000;

            List<List<Double>> p_matrix = new ArrayList<>();
            init_matrix(p_num, p_matrix);

            for (int i = 0; i < iNN; i++) {
                dXShXiGeMa[i] = dFunXShXiGeMa_n(chongci / 60 * 2 * Math.PI, 60 / chongci / TotalPoint, i, dYeZhong,
                        TotalPoint);
                dXShMiu[i] = dFunXShMiu_n(chongci / 60 * 2 * Math.PI, 60 / chongci / TotalPoint, i, DdiMianWY, TotalPoint);
                dXShTao[i] = dFunXShTao_n(chongci / 60 * 2 * Math.PI, 60 / chongci / TotalPoint, i, dYeZhong,
                        TotalPoint);
                dXShDeErTa[i] = dFunXShDeErTa_n(chongci / 60 * 2 * Math.PI, 60 / chongci / TotalPoint, i, DdiMianWY,
                        TotalPoint);
                p_matrix.get(sigma_n).set(i, dXShXiGeMa[i]);
                p_matrix.get(nu_n).set(i, dXShMiu[i]);
                p_matrix.get(tau_n).set(i, dXShTao[i]);
                p_matrix.get(delta_n).set(i, dXShDeErTa[i]);
            }
            dZNXShC = dFunZLXShC(chongci / 60 * 2 * Math.PI, 4968, Viscosity, GanMidu, dGanJing * dGanJing * 0.25 * Math.PI,
                    Tubingsize,
                    dGanJing, dNowGanSh);
            tmpdZuNiCup = dZNXShC;

            for (int i = 0; i < iNN; i++) {
                dXSha[i] = dFunXSha_n(chongci / 60 * 2 * Math.PI, i, tmpdZuNiCup, 4968);
                dXShB[i] = dFunXShB_n(chongci / 60 * 2 * Math.PI, i, tmpdZuNiCup, 4968);
                dXShK[i] = dFunXShK_n(dXSha[i], dXShB[i], dXShXiGeMa[i], dXShTao[i], DXML_E,
                        dGanJing * dGanJing * 0.25 * Math.PI);
                dXSHU[i] = dFunXShU_n(dXSha[i], dXShB[i], dXShXiGeMa[i], dXShTao[i], DXML_E,
                        dGanJing * dGanJing * 0.25 * Math.PI);
                p_matrix.get(alpha_n).set(i, dXSha[i]);
                p_matrix.get(beta_n).set(i, dXShB[i]);
                p_matrix.get(kappa_n).set(i, dXShK[i]);
                p_matrix.get(mu_n).set(i, dXSHU[i]);
            }
            for (int i = 0; i < iNN; i++) {
                dZhJZhO[i] = dFunO_n(dNowGanSh, dXShK[i], dXShB[i], dXShDeErTa[i], dXSha[i], dXSHU[i], dXShMiu[i]);
                dZhJZhP[i] = dFunP_n(dNowGanSh, dXShK[i], dXShB[i], dXShDeErTa[i], dXSha[i], dXSHU[i], dXShMiu[i]);
                dZhJZhPianO[i] = dFunPianO_n(dNowGanSh, dXShK[i], dXShB[i], dXShDeErTa[i], dXSha[i], dXSHU[i], dXShMiu[i],
                        dXShTao[i], dXShXiGeMa[i], DXML_E, dGanJing * dGanJing * 0.25 * Math.PI);
                dZhJZhPianP[i] = dFunPianP_n(dNowGanSh, dXShK[i], dXShB[i], dXShDeErTa[i], dXSha[i], dXSHU[i], dXShMiu[i],
                        dXShTao[i], dXShXiGeMa[i], DXML_E, dGanJing * dGanJing * 0.25 * Math.PI);
            }
            List<Double> Dbu_1 = new ArrayList<>();
            List<Double> Dbu_2 = new ArrayList<>();
            Dbu.add(Dbu_1);
            Dbu.add(Dbu_2);
            for (int i = 0; i < UpPoint; i++) {
//        dbengu[i] = dFunUxt(dNowGanSh, chongci / 60 * 2 * Math.PI, dXShXiGeMa[0], dXShMiu[0], DXML_E,
//                            dGanJing * dGanJing * 0.25 * Math.PI, iNN, dZhJZhO, dZhJZhP,
//                            60 / chongci / TotalPoint * i);
//        dbengf[i] = dFunFxt(chongci / 60 * 2 * Math.PI, dXShXiGeMa[0], DXML_E, dGanJing * dGanJing * 0.25 * Math.PI,
//                            iNN,
//                            dZhJZhPianO, dZhJZhPianP, 60 / chongci / TotalPoint * i);
                double dbu0i = dFunUxt(dNowGanSh, chongci / 60 * 2 * Math.PI, dXShXiGeMa[0],
                        dXShMiu[0], DXML_E,
                        dGanJing * dGanJing * 0.25 * Math.PI, iNN, dZhJZhO, dZhJZhP,
                        60 / chongci / TotalPoint * i);
                Dbu.get(0).add(dbu0i);
                double dbu1i = dFunFxt(chongci / 60 * 2 * Math.PI, dXShXiGeMa[0], DXML_E,
                        dGanJing * dGanJing * 0.25 * Math.PI,
                        iNN,
                        dZhJZhPianO, dZhJZhPianP, 60 / chongci / TotalPoint * i);
                Dbu.get(1).add(dbu1i);

                if (Dbu.get(0).get(i) < MinshiftPoint) {
                    MinshiftPoint = Dbu.get(0).get(i);
                    dzxwyzh = Dbu.get(1).get(i) / 1000;
                    dzxwy = MinshiftPoint;
                }
                if (Dbu.get(1).get(i) > bmaxload) {
                    bmaxload = Dbu.get(1).get(i);
                    dbmaxload = Dbu.get(1).get(i) / 1000;
                }
                if (Dbu.get(1).get(i) < bminload) {
                    bminload = Dbu.get(1).get(i);
                    dbminload = Dbu.get(1).get(i) / 1000;
                }
            }
            tmpdZuNiCdown = 1.2 * dZNXShC;
            for (int i = 0; i < iNN; i++) {
                dXSha[i] = dFunXSha_n(chongci / 60 * 2 * Math.PI, i, tmpdZuNiCdown, 4968);
                dXShB[i] = dFunXShB_n(chongci / 60 * 2 * Math.PI, i, tmpdZuNiCdown, 4968);
                dXShK[i] = dFunXShK_n(dXSha[i], dXShB[i], dXShXiGeMa[i], dXShTao[i], DXML_E,
                        dGanJing * dGanJing * 0.25 * Math.PI);
                dXSHU[i] = dFunXShU_n(dXSha[i], dXShB[i], dXShXiGeMa[i], dXShTao[i], DXML_E,
                        dGanJing * dGanJing * 0.25 * Math.PI);
            }
            for (int i = 0; i < iNN; i++) {
                dZhJZhO[i] = dFunO_n(dNowGanSh, dXShK[i], dXShB[i], dXShDeErTa[i], dXSha[i], dXSHU[i], dXShMiu[i]);
                dZhJZhP[i] = dFunP_n(dNowGanSh, dXShK[i], dXShB[i], dXShDeErTa[i], dXSha[i], dXSHU[i], dXShMiu[i]);
                dZhJZhPianO[i] = dFunPianO_n(dNowGanSh, dXShK[i], dXShB[i], dXShDeErTa[i], dXSha[i], dXSHU[i], dXShMiu[i],
                        dXShTao[i], dXShXiGeMa[i], DXML_E, dGanJing * dGanJing * 0.25 * Math.PI);
                dZhJZhPianP[i] = dFunPianP_n(dNowGanSh, dXShK[i], dXShB[i], dXShDeErTa[i], dXSha[i], dXSHU[i], dXShMiu[i],
                        dXShTao[i], dXShXiGeMa[i], DXML_E, dGanJing * dGanJing * 0.25 * Math.PI);
            }
            for (int i = UpPoint; i < TotalPoint; i++) {
                dbengu[i] = dFunUxt(dNowGanSh, chongci / 60 * 2 * Math.PI, dXShXiGeMa[0], dXShMiu[0], DXML_E,
                        dGanJing * dGanJing * 0.25 * Math.PI, iNN, dZhJZhO, dZhJZhP,
                        60 / chongci / TotalPoint * (i - 1));
                dbengf[i] = dFunFxt(chongci / 60 * 2 * Math.PI, dXShXiGeMa[0], DXML_E, dGanJing * dGanJing * 0.25 * Math.PI,
                        iNN,
                        dZhJZhPianO, dZhJZhPianP, 60 / chongci / TotalPoint * (i - 1));
                double Dbu0i = dFunUxt(dNowGanSh, chongci / 60 * 2 * Math.PI, dXShXiGeMa[0], dXShMiu[0], DXML_E,
                        dGanJing * dGanJing * 0.25 * Math.PI, iNN, dZhJZhO, dZhJZhP,
                        60 / chongci / TotalPoint * (i - 1));
                Dbu.get(0).add(Dbu0i);
                double Dbu1i = dFunFxt(chongci / 60 * 2 * Math.PI, dXShXiGeMa[0], DXML_E, dGanJing * dGanJing * 0.25 * Math.PI,
                        iNN,
                        dZhJZhPianO, dZhJZhPianP, 60 / chongci / TotalPoint * (i - 1));
                Dbu.get(1).add(Dbu1i);
                if (Dbu.get(0).get(i) < MinshiftPoint) {
                    MinshiftPoint = Dbu.get(0).get(i);
                    dzxwyzh = Dbu.get(1).get(i) / 1000;
                    dzxwy = MinshiftPoint;
                }
                if (Dbu.get(1).get(i) > bmaxload) {
                    bmaxload = Dbu.get(1).get(i);
                    dbmaxload = Dbu.get(1).get(i) / 1000;
                }
                if (Dbu.get(1).get(i) < bminload) {
                    bminload = Dbu.get(1).get(i);
                    dbminload = Dbu.get(1).get(i) / 1000;
                }
            }
            ddZNXShC = dZNXShC;
            return Dbu;
        }

        double c_C(double A_r, double miu_o, double D_t, double D_r, double rou_r, double w, double x, double a) {
            double m = D_t / D_r;
            double B1 = (m * m - 1) / (2 * Math.log(m)) - 1;
            double B2 = Math.pow(m, 4) - 1 - Math.pow(m * m - 1, 2) / Math.log(m);
            double c = 2 * Math.PI * miu_o / rou_r / A_r *
                    (1 / Math.log(m) + 4 / B2 * (B1 + 1) * (B1 + 2 / (w * x / a / Math.sin(w * x / a) + Math.cos(w * x / a))));
            return c;
        }

        boolean c_rod_diagram(pumpCard pc, double s, double f, double E_r, double rho_r,
                              double miu_o,
                              double x, double D_r, double D_t, int n) {
            int K = pc.total_point;
//    rho_r = 7850;
//    E_r = 2.1 * Math.pow(10, 11);
//    D_r = 0.0545;
            double dt = 60 / f / K;
            double omega = 2 * Math.PI * f / 60;
            double a = Math.sqrt(E_r / rho_r);
//    a = 4968;
            double A_r = Math.PI * D_r * D_r / 4;
            double c = c_C(A_r, miu_o, D_t, D_r, rho_r, omega, x, a);

            List<List<Double>> p_matrix = new ArrayList<>();
            init_matrix(n, p_matrix);
            for (int i = 0; i < n; ++i)
                for (int j = 0; j < p_num; ++j)
                    c_p_matrix(p_matrix, K, E_r, A_r, omega, dt, a, c, x, j, i, pc.dbu);
            ;

            List<List<Double>> duf = new ArrayList<>();
            for (int i = 0; i < K; ++i) {
                double t = i * dt;
                double tempA = 0;
                double tempP = 0;
                for (int j = 1; j < n; ++j) {
                    tempA += p_matrix.get(O_n).get(j) * Math.cos(j * omega * t) + p_matrix.get(P_n).get(j) * Math.sin(j * omega * t);
                    tempP += p_matrix.get(O_n_2).get(j) * Math.cos(j * omega * t) + p_matrix.get(P_n_2).get(j) * Math.sin(j * omega * t);
                }
                List<Double> point = new ArrayList<>();
                point.add(p_matrix.get(sigma_n).get(0) / 2 / E_r / A_r * x + p_matrix.get(nu_n).get(0) / 2 + tempA);
                point.add(E_r * A_r * (p_matrix.get(sigma_n).get(0) / 2 / E_r / A_r + tempP));
                point.set(1, point.get(1) / 1000.0);
                duf.add(point);
            }
            return pc.checkCard(duf, false);
        }

        double ch(double x) {
            return (Math.exp(x) + Math.exp(-x)) * 0.5;
        }

        double sh(double x) {
            return (Math.exp(x) - Math.exp(-x)) * 0.5;
        }

        void
        c_p_matrix(List<List<Double>> p_matrix, int K, double E_r, double A_r, double omega, double dt,
                   double a,
                   double c, double x, int p_num_cur, int n_cur, List<List<Double>> sgt) {
            switch (p_num_cur) {
                case alpha_n:
                    p_matrix.get(p_num_cur).set(n_cur,
                            (n_cur + 1) * omega / Math.sqrt(2) / a *
                                    Math.sqrt(1 + Math.sqrt(1 + Math.pow(c / (n_cur + 1) / omega, 2))));
                    break;
                case beta_n:
                    p_matrix.get(p_num_cur).set(n_cur,
                            (n_cur + 1) * omega / Math.sqrt(2) / a *
                                    Math.sqrt(-1 + Math.sqrt(1 + Math.pow(c / (n_cur + 1) / omega, 2))));
                    break;
                case sigma_n: {
                    double temp = 0;
                    for (int i = 0; i < K; ++i)
                        temp += (sgt.get(i).get(1) * 1000) * Math.cos(n_cur * omega * i * dt) * dt;
                    p_matrix.get(p_num_cur).set(n_cur, temp * omega / Math.PI);
                    break;
                }
                case tau_n: {
                    double temp = 0;
                    for (int i = 0; i < K; ++i)
                        temp += (sgt.get(i).get(1) * 1000) * Math.sin(n_cur * omega * i * dt) * dt;
                    p_matrix.get(p_num_cur).set(n_cur, temp * omega / Math.PI);
                    break;
                }
                case nu_n: {
                    double temp = 0;
                    for (int i = 0; i < K; ++i) temp += sgt.get(i).get(0) * Math.cos(n_cur * omega * i * dt) * dt;
                    p_matrix.get(p_num_cur).set(n_cur, temp * omega / Math.PI);
                    break;
                }
                case delta_n: {
                    double temp = 0;
                    for (int i = 0; i < K; ++i) temp += sgt.get(i).get(0) * Math.sin(n_cur * omega * i * dt) * dt;
                    p_matrix.get(p_num_cur).set(n_cur, temp * omega / Math.PI);
                    break;
                }
                case kappa_n: {
                    p_matrix.get(p_num_cur).set(n_cur, (p_matrix.get(sigma_n).get(n_cur) * p_matrix.get(alpha_n).get(n_cur) +
                            p_matrix.get(sigma_n).get(n_cur) * p_matrix.get(beta_n).get(n_cur)) /
                            E_r / A_r /
                            (Math.pow(p_matrix.get(alpha_n).get(n_cur), 2) + Math.pow(p_matrix.get(beta_n).get(n_cur), 2)));
                    break;
                }
                case mu_n: {
                    p_matrix.get(p_num_cur).set(n_cur, (p_matrix.get(sigma_n).get(n_cur) * p_matrix.get(beta_n).get(n_cur) -
                            p_matrix.get(tau_n).get(n_cur) * p_matrix.get(alpha_n).get(n_cur)) /
                            E_r / A_r /
                            (Math.pow(p_matrix.get(alpha_n).get(n_cur), 2) + Math.pow(p_matrix.get(beta_n).get(n_cur), 2)));
                    break;
                }
                case O_n: {
                    p_matrix.get(p_num_cur).set(n_cur, (p_matrix.get(kappa_n).get(n_cur) * ch(p_matrix.get(beta_n).get(n_cur) * x) +
                            p_matrix.get(delta_n).get(n_cur) * sh(p_matrix.get(beta_n).get(n_cur) * x)) *
                            Math.sin(p_matrix.get(alpha_n).get(n_cur) * x) +
                            (p_matrix.get(mu_n).get(n_cur) * sh(p_matrix.get(beta_n).get(n_cur) * x) +
                                    p_matrix.get(nu_n).get(n_cur) * ch(p_matrix.get(beta_n).get(n_cur) * x)) *
                                    Math.cos(p_matrix.get(alpha_n).get(n_cur) * x));
                    break;
                }
                case P_n: {
                    p_matrix.get(p_num_cur).set(n_cur, (p_matrix.get(kappa_n).get(n_cur) * sh(p_matrix.get(beta_n).get(n_cur) * x) +
                            p_matrix.get(delta_n).get(n_cur) * ch(p_matrix.get(beta_n).get(n_cur) * x)) *
                            Math.cos(p_matrix.get(alpha_n).get(n_cur) * x) -
                            (p_matrix.get(mu_n).get(n_cur) * ch(p_matrix.get(beta_n).get(n_cur) * x) +
                                    p_matrix.get(nu_n).get(n_cur) * sh(p_matrix.get(beta_n).get(n_cur) * x)) *
                                    Math.sin(p_matrix.get(alpha_n).get(n_cur) * x));
                    break;
                }
                case O_n_2: {
                    p_matrix.get(p_num_cur).set(n_cur, (p_matrix.get(tau_n).get(n_cur) / E_r / A_r * sh(p_matrix.get(beta_n).get(n_cur) * x) +
                            (p_matrix.get(delta_n).get(n_cur) * p_matrix.get(beta_n).get(n_cur) -
                                    p_matrix.get(nu_n).get(n_cur) * p_matrix.get(alpha_n).get(n_cur)) *
                                    ch(p_matrix.get(beta_n).get(n_cur) * x)) *
                            Math.sin(p_matrix.get(alpha_n).get(n_cur) * x) +
                            (p_matrix.get(sigma_n).get(n_cur) / E_r / A_r *
                                    ch(p_matrix.get(beta_n).get(n_cur) * x) +
                                    (p_matrix.get(nu_n).get(n_cur) * p_matrix.get(beta_n).get(n_cur) +
                                            p_matrix.get(delta_n).get(n_cur) * p_matrix.get(alpha_n).get(n_cur)) *
                                            sh(p_matrix.get(beta_n).get(n_cur) * x)) *
                                    Math.cos(p_matrix.get(alpha_n).get(n_cur) * x));
                    break;
                }
                case P_n_2: {
                    p_matrix.get(p_num_cur).set(n_cur, (p_matrix.get(tau_n).get(n_cur) / (E_r * A_r) * ch(p_matrix.get(beta_n).get(n_cur) * x) +
                            (p_matrix.get(delta_n).get(n_cur) * p_matrix.get(beta_n).get(n_cur) -
                                    p_matrix.get(nu_n).get(n_cur) * p_matrix.get(alpha_n).get(n_cur)) *
                                    sh(p_matrix.get(beta_n).get(n_cur) * x)) *
                            Math.cos(p_matrix.get(alpha_n).get(n_cur) * x) -
                            (p_matrix.get(sigma_n).get(n_cur) / (E_r * A_r) *
                                    sh(p_matrix.get(beta_n).get(n_cur) * x) +
                                    (p_matrix.get(nu_n).get(n_cur) * p_matrix.get(beta_n).get(n_cur) +
                                            p_matrix.get(delta_n).get(n_cur) * p_matrix.get(alpha_n).get(n_cur)) *
                                            ch(p_matrix.get(beta_n).get(n_cur) * x)) *
                                    Math.sin(p_matrix.get(alpha_n).get(n_cur) * x));
                    break;
                }
            }
        }

        public boolean c_pump_diagram(DgnsGtbaseparam _base, pumpCard pc, double D_t, double D_t_loss,
                                      double L_p,
                                      double D_p) {
            pc.checkCard(SGTUtil.encodeToUseList(_base.getSgt()), true);
            D_t = D_t * (1 - D_t_loss);

            aoidRodsModule.formatRodDetail();
            c_multi_rod_diagram(pc, Double.parseDouble(_base.getS()), Double.parseDouble(_base.getN()),
                    Double.parseDouble(aoidRodsModule.getRodE()), Double.parseDouble(aoidRodsModule.getRodDensity()),
                    0.032, L_p, D_t, 10, aoidRodsModule.getRodsDetailFormat());
            return true;
        }

        void
        c_p_matrix_common(List<List<Double>> p_matrix, double E_r, double A_r, double x, int p_num_cur,
                          int n_cur) {
            switch (p_num_cur) {
                case kappa_n: {
                    p_matrix.get(p_num_cur).set(n_cur, (p_matrix.get(sigma_n).get(n_cur) * p_matrix.get(alpha_n).get(n_cur) +
                            p_matrix.get(sigma_n).get(n_cur) * p_matrix.get(beta_n).get(n_cur)) /
                            E_r / A_r /
                            (Math.pow(p_matrix.get(alpha_n).get(n_cur), 2) + Math.pow(p_matrix.get(beta_n).get(n_cur), 2)));
                    break;
                }
                case mu_n: {
                    p_matrix.get(p_num_cur).set(n_cur, (p_matrix.get(sigma_n).get(n_cur) * p_matrix.get(beta_n).get(n_cur) -
                            p_matrix.get(tau_n).get(n_cur) * p_matrix.get(alpha_n).get(n_cur)) /
                            E_r / A_r /
                            (Math.pow(p_matrix.get(alpha_n).get(n_cur), 2) + Math.pow(p_matrix.get(beta_n).get(n_cur), 2)));
                    break;
                }
                case O_n: {
                    p_matrix.get(p_num_cur).set(n_cur, (p_matrix.get(kappa_n).get(n_cur) * ch(p_matrix.get(beta_n).get(n_cur) * x) +
                            p_matrix.get(delta_n).get(n_cur) * sh(p_matrix.get(beta_n).get(n_cur) * x)) *
                            Math.sin(p_matrix.get(alpha_n).get(n_cur) * x) +
                            (p_matrix.get(mu_n).get(n_cur) * sh(p_matrix.get(beta_n).get(n_cur) * x) +
                                    p_matrix.get(nu_n).get(n_cur) * ch(p_matrix.get(beta_n).get(n_cur) * x)) *
                                    Math.cos(p_matrix.get(alpha_n).get(n_cur) * x));
                    break;
                }
                case P_n: {
                    p_matrix.get(p_num_cur).set(n_cur, (p_matrix.get(kappa_n).get(n_cur) * sh(p_matrix.get(beta_n).get(n_cur) * x) +
                            p_matrix.get(delta_n).get(n_cur) * ch(p_matrix.get(beta_n).get(n_cur) * x)) *
                            Math.cos(p_matrix.get(alpha_n).get(n_cur) * x) -
                            (p_matrix.get(mu_n).get(n_cur) * ch(p_matrix.get(beta_n).get(n_cur) * x) +
                                    p_matrix.get(nu_n).get(n_cur) * sh(p_matrix.get(beta_n).get(n_cur) * x)) *
                                    Math.sin(p_matrix.get(alpha_n).get(n_cur) * x));
                    break;
                }
                case O_n_2: {
                    p_matrix.get(p_num_cur).set(n_cur, (p_matrix.get(tau_n).get(n_cur) / E_r / A_r * sh(p_matrix.get(beta_n).get(n_cur) * x) +
                            (p_matrix.get(delta_n).get(n_cur) * p_matrix.get(beta_n).get(n_cur) -
                                    p_matrix.get(nu_n).get(n_cur) * p_matrix.get(alpha_n).get(n_cur)) *
                                    ch(p_matrix.get(beta_n).get(n_cur) * x)) *
                            Math.sin(p_matrix.get(alpha_n).get(n_cur) * x) +
                            (p_matrix.get(sigma_n).get(n_cur) / E_r / A_r *
                                    ch(p_matrix.get(beta_n).get(n_cur) * x) +
                                    (p_matrix.get(nu_n).get(n_cur) * p_matrix.get(beta_n).get(n_cur) +
                                            p_matrix.get(delta_n).get(n_cur) * p_matrix.get(alpha_n).get(n_cur)) *
                                            sh(p_matrix.get(beta_n).get(n_cur) * x)) *
                                    Math.cos(p_matrix.get(alpha_n).get(n_cur) * x));
                    break;
                }
                case P_n_2: {
                    p_matrix.get(p_num_cur).set(n_cur, (p_matrix.get(tau_n).get(n_cur) / (E_r * A_r) * ch(p_matrix.get(beta_n).get(n_cur) * x) +
                            (p_matrix.get(delta_n).get(n_cur) * p_matrix.get(beta_n).get(n_cur) -
                                    p_matrix.get(nu_n).get(n_cur) * p_matrix.get(alpha_n).get(n_cur)) *
                                    sh(p_matrix.get(beta_n).get(n_cur) * x)) *
                            Math.cos(p_matrix.get(alpha_n).get(n_cur) * x) -
                            (p_matrix.get(sigma_n).get(n_cur) / (E_r * A_r) *
                                    sh(p_matrix.get(beta_n).get(n_cur) * x) +
                                    (p_matrix.get(nu_n).get(n_cur) * p_matrix.get(beta_n).get(n_cur) +
                                            p_matrix.get(delta_n).get(n_cur) * p_matrix.get(alpha_n).get(n_cur)) *
                                            ch(p_matrix.get(beta_n).get(n_cur) * x)) *
                                    Math.sin(p_matrix.get(alpha_n).get(n_cur) * x));
                    break;
                }
            }
        }

        void
        c_p_matrix_first(List<List<Double>> p_matrix, int K, double E_r, double A_r, double omega,
                         double dt,
                         double a, double c, double x, int p_num_cur, int n_cur, List<List<Double>> sgt) {
            switch (p_num_cur) {
                case alpha_n:
                    p_matrix.get(p_num_cur).set(n_cur,
                            (n_cur + 1) * omega / Math.sqrt(2) / a *
                        Math.sqrt(1 + Math.sqrt(1 + Math.pow(c / (n_cur + 1) / omega, 2))));
                    break;
                case beta_n:
                    p_matrix.get(p_num_cur).set(n_cur,
                            (n_cur + 1) * omega / Math.sqrt(2) / a *
                        Math.sqrt(-1 + Math.sqrt(1 + Math.pow(c / (n_cur + 1) / omega, 2))));
                    break;
                case sigma_n: {
                    double temp = 0;
                    for (int i = 0; i < K; ++i)
                        temp += (sgt.get(i).get(1) * 1000) * Math.cos(n_cur * omega * i * dt) * dt;
                    p_matrix.get(p_num_cur).set(n_cur,temp * omega / Math.PI);
                    break;
                }
                case tau_n: {
                    double temp = 0;
                    for (int i = 0; i < K; ++i)
                        temp += (sgt.get(i).get(1) * 1000) * Math.sin(n_cur * omega * i * dt) * dt;
                    p_matrix.get(p_num_cur).set(n_cur,temp * omega / Math.PI);
                    break;
                }
                case nu_n: {
                    double temp = 0;
                    for (int i = 0; i < K; ++i) temp += sgt.get(i).get(0) * Math.cos(n_cur * omega * i * dt) * dt;
                    p_matrix.get(p_num_cur).set(n_cur,temp * omega / Math.PI);
                    break;
                }
                case delta_n: {
                    double temp = 0;
                    for (int i = 0; i < K; ++i) temp += sgt.get(i).get(0) * Math.sin(n_cur * omega * i * dt) * dt;
                    p_matrix.get(p_num_cur).set(n_cur,temp * omega / Math.PI);
                    break;
                }
                default:
                    c_p_matrix_common(p_matrix, E_r, A_r, x, p_num_cur, n_cur);
            }
        }

        void c_p_matrix_next(List<List<Double>> p_matrix, double E_r_pre, double A_r_pre, double E_r,
                             double A_r,
                             double x, double L_pre, int p_num_cur, int n_cur) {
            switch (p_num_cur) {
                case alpha_n:
                    break;
                case beta_n:
                    break;
                case sigma_n: {
                    if (n_cur == 0) return;
                    p_matrix.get(p_num_cur).set(n_cur,E_r_pre * A_r_pre * p_matrix.get(O_n_2).get(n_cur));
                    break;
                }
                case tau_n: {
                    p_matrix.get(p_num_cur).set(n_cur,E_r_pre * A_r_pre * p_matrix.get(P_n_2).get(n_cur));
                    break;
                }
                case nu_n: {
                    if (n_cur > 0)
                        p_matrix.get(p_num_cur).set(n_cur,p_matrix.get(O_n).get(n_cur));
                    else
                        p_matrix.get(p_num_cur).set(n_cur,p_matrix.get(sigma_n).get(0) / E_r_pre / A_r_pre * L_pre + p_matrix.get(nu_n).get(0));
                    break;
                }
                case delta_n: {
                    p_matrix.get(p_num_cur).set(n_cur,p_matrix.get(P_n).get(n_cur));
                    break;
                }
                default:
                    c_p_matrix_common(p_matrix, E_r, A_r, x, p_num_cur, n_cur);
            }
        }

        class rods_group {
            List<rod_info> rods = new ArrayList<>();
            int rod_level;
            double A_r_avg;
            double D_r_avg;
        }

        ;

        class rod_info {
            //直径 m
            double D_r;
            //长度/深度 m
            double L_r;
            //横截面积 平方米
            double A_r;
        }

        ;

        boolean handle_rods_data(List<List<Double>> rods, double L_p, rods_group group) {
            if (rods.isEmpty()) return false;
            group.rod_level = rods.size();
            double temp = 0, temp2 = 0;
            for (int i = 0; i < rods.size(); ++i) {
                rod_info info = new rod_info();
                info.D_r = rods.get(i).get(0) / 1000.0;//mm转m
                info.L_r = L_p * rods.get(i).get(1) / 100;//换算本级杆长度 m
                info.A_r = Math.PI * info.D_r * info.D_r / 4;//加入杆柱横截面积
                temp += info.A_r * info.L_r;
                temp2 += info.D_r * info.L_r;
                group.rods.add(info);
            }
            group.A_r_avg = temp / L_p;//加入一个平均横截面积
            group.D_r_avg = temp2 / L_p;//加入一个平均杆直径
            return true;
        }

        boolean
        c_multi_rod_diagram(pumpCard pc, double s, double f, double E_r, double rho_r, double mu_o, double L_p,
                            double D_t,
                            int n, List<List<Double>> rods) {
            //对杆柱组合数据加工一下
            rods_group group = new rods_group();
            handle_rods_data(rods, L_p, group);
            int K = pc.total_point;
            //    rho_r = 7850;
            //    E_r = 2.1 * Math.pow(10, 11);
            //    D_r = 0.0545;
            double dt = 60 / f / K;
            double omega = 2 * Math.PI * f / 60;
            double a = Math.sqrt(E_r / rho_r);
            //    a = 4968;
            double c = c_C(group.A_r_avg, mu_o, D_t, group.D_r_avg, rho_r, omega, L_p, a);

            List<List<Double>> p_matrix = new ArrayList<>();
            init_matrix(n, p_matrix);

            //计算傅立叶参数
            double L_r_pre = 0, A_r_pre = 0, x = 0;
            for (int level = 0; level < group.rod_level; ++level) {
                x += group.rods.get(level).L_r;
                double A_r = group.rods.get(level).A_r;
                double L_r = group.rods.get(level).L_r;
                if (level == 0) {
                    for (int i = 0; i < n; ++i)
                        for (int j = 0; j < p_num; ++j)
                            c_p_matrix_first(p_matrix, K, E_r, A_r, omega, dt, a, c, -x, j, i, pc.dbu);
                } else {
                    for (int i = 0; i < n; ++i)
                        for (int j = 0; j < p_num; ++j)
                            c_p_matrix_next(p_matrix, E_r, A_r_pre, E_r, A_r, -x, L_r_pre, j, i);
                }

                A_r_pre = A_r;
                L_r_pre = L_r;
            }

            //生成功图
            List<List<Double>> duf = new ArrayList<>();
            for (int i = 0; i < K; ++i) {
                double t = i * dt;
                double tempA = 0;
                double tempP = 0;
                for (int j = 1; j < n; ++j) {
                    tempA += p_matrix.get(O_n).get(j) * Math.cos(j * omega * t) + p_matrix.get(P_n).get(j) * Math.sin(j * omega * t);
                    tempP += p_matrix.get(O_n_2).get(j) * Math.cos(j * omega * t) + p_matrix.get(P_n_2).get(j) * Math.sin(j * omega * t);
                }
                List<Double> point = new ArrayList<>();
                point.add(p_matrix.get(sigma_n).get(0) / 2 / E_r / A_r_pre * x + p_matrix.get(nu_n).get(0) / 2 + tempA);
                point.add(E_r * A_r_pre * (p_matrix.get(sigma_n).get(0) / 2 / E_r / A_r_pre + tempP));
                point.set(1, point.get(1) / 1000.0);
                duf.add(point);
            }
            return pc.checkCard(duf, false);
        }
    }

    ;

    class CardSlopeRec {
        double Card_Shift;
        double Card_Slope;
        double PumpCard_Shift;
        double PumpCard_Slope;
    }

    ;

    /**
     * @return 日产液量 日产油量 日产水量 日产气量 泵效  理论排量 实际冲程 有效冲程 左冲程  右冲程 冲程损失 漏失损失 gyss 有效冲程比例
     */
    public List<Double> cal_ylandon(List<List<Double>> sgt, List<List<Double>> bgt, double cc, double cc1,
                                    String zdjg, double bj,
                                    double bs, double hsl, double smd, double ymd, double qyb, double dym, double bdxs, double gradient_1,
                                    double gradient_10, double gradient_2, double gradient_3, double gradient_4, double gradient_5,
                                    double gradient_6, double gradient_7, double gradient_8, double gradient_9, double dividenum_1,
                                    double dividenum_2, double dividenum_3, double dividenum_4, double dividenum_5, double dividenum_6,
                                    double dividenum_7, double dividenum_8, double dividenum_9, double dividenum_10) {
        double Card_MaxShift;
        double Card_MinShift;
        double Card_MaxLoad;
        double Card_MinLoad;
        double Card_Power;
        double PumpCard_MaxShift;
        double PumpCard_MinShift;
        double PumpCard_MaxLoad;
        double PumpCard_MinLoad;
        double PumpCard_Power;

        List<CardSlopeRec> CardSlope_array = new ArrayList<>();

        int Card_Point;
        String L_cjsj;
        String L_jh;
        List<List<Double>> L_bgt = new ArrayList<>();
        List<List<Double>> L_sgt = new ArrayList<>();

        double L_Cycle;
        double L_Cc;
        double L_Bj;
        double L_Llbj;
        double L_Hs;
        double L_Bx;
        double L_Rcl;
        double L_Rcyl;
        double L_Rcsl;
        double L_RclT;
        double L_RcylT;
        double L_RcslT;
        double L_Rcql;
        double L_Ccsmd;
        double L_Dmyybz;
        double L_Qyb;
        double L_Dym;
        double L_Cmd;
        double L_Bs;

        double L_DownLoadLevel = 0;
        double L_UpLoadLevel = 0;
        double L_TheoryLoadLiquid = 0;
        double Productioncoefficient = 0;

        double L_TempDownLevel;
        double L_TempUpLevel;
        int L_TempNum;

        String L_Zdjg;
        String L_ZdjgJc;
        String L_Load;
        String L_Shift;
        String L_ShiftLoad;
        int L_Count;
        double l_StrokeRatio;

        int I = 1;
        int j = 0;
        int L_LeftDownPoint;
        int L_RightDownPoint;

        double L_LeftDownLoad;
        double L_RightDownLoad;
        double L_LeftDownStroke;
        double L_LeftDownStroke1;
        double L_LeftDownStroke2;
        double L_RightDownStroke;

        int L_LeftUpPoint;
        int L_RightUpPoint;
        double L_LeftUpLoad;
        double L_RightUpLoad;
        double L_LeftUpStroke;
        double L_RightUpStroke;
        double L_UpEffectiveStroke;
        double L_DivideLoad;

        String L_Zyq;
        double L_Sjcc;
        double L_Yxcc;
        double L_Zcc;
        double L_Ycc;
        double L_Ccss;
        double L_Llpl;
        double L_Lsss;
        double L_Gyss;
        double L_PumpDepth = 0;

        double L_DivideNum;
        double L_LeftDownLeak;
        double L_DownPointDivide;

        double L_Gradient = 15;
        double L_Gradient1 = 15;
        int L_UpPointDivide = 0;
        double L_Bdxs1;
        double L_Bdxs;
        L_sgt = sgt;
        L_bgt = bgt;
        L_Cc = cc;
        L_Cycle = cc1;
        L_Zdjg = zdjg;
        L_Bj = bj;
        L_Bs = bs;
        L_Hs = hsl;
        L_Ccsmd = smd;
        L_Dmyybz = ymd;
        L_Qyb = qyb;
        L_Dym = dym;
        L_Bdxs = bdxs;
        //L_zyq = zyq;
        L_LeftDownStroke = 0;
        L_LeftDownPoint = 0;
        L_LeftDownLoad = 0;
        Card_MaxShift = 0;
        Card_MinShift = 0;
        Card_MaxLoad = 0;
        Card_MinLoad = 0;
        Card_Power = 0;
        PumpCard_MaxShift = 0;
        PumpCard_MinShift = 0;
        PumpCard_MaxLoad = 0;
        PumpCard_MinLoad = 0;
        PumpCard_Power = 0;
        Card_Point = 0;
        Card_Point = L_sgt.size();
        Card_Power = 0;
        PumpCard_Power = 0;
        L_LeftDownStroke1 = 15;
        L_LeftDownStroke2 = -15;
        //Card_MaxLoad=std::atof(L_sgt.substr(3+8*(-1),5))/100;
        for (int i = 0; i < Card_Point; i++) {
            CardSlopeRec CardSlope = new CardSlopeRec();
        /* Card_Shift = L_sgt.get(i).get(0);
         Card_Load = L_sgt.get(i).get(1);
         PumpCard_Shift = L_bgt.get(i).get(0);
         PumpCard_Load = L_bgt.get(i).get(1);*/

            int previousindex = i - 1;
            if (i == 0) {
                previousindex = Card_Point - 1;
                Card_MaxLoad = L_sgt.get(i).get(1);
                Card_MinLoad = L_sgt.get(i).get(1);
                Card_MaxShift = L_sgt.get(i).get(0);
                Card_MinShift = L_sgt.get(i).get(0);
                PumpCard_MaxLoad = L_bgt.get(i).get(1);
                PumpCard_MinLoad = L_bgt.get(i).get(1);
                PumpCard_MaxShift = L_bgt.get(i).get(0);
                PumpCard_MinShift = L_bgt.get(i).get(0);
                L_LeftDownStroke = L_bgt.get(i).get(0);
                L_LeftDownLoad = L_bgt.get(i).get(1);
                L_LeftDownPoint = i;
            }
            if (Card_MaxLoad < L_sgt.get(i).get(1)) Card_MaxLoad = L_sgt.get(i).get(1);
            else if (Card_MinLoad > L_sgt.get(i).get(1)) Card_MinLoad = L_sgt.get(i).get(1);

            if (Card_MaxShift < L_sgt.get(i).get(0)) Card_MaxShift = L_sgt.get(i).get(0);
            else if (Card_MinShift > L_sgt.get(i).get(0)) Card_MinShift = L_sgt.get(i).get(0);

            if (PumpCard_MaxLoad < L_bgt.get(i).get(1)) PumpCard_MaxLoad = L_bgt.get(i).get(1);
            else if (PumpCard_MinLoad > L_bgt.get(i).get(1)) PumpCard_MinLoad = L_bgt.get(i).get(1);
            if (PumpCard_MaxShift < L_bgt.get(i).get(0)) PumpCard_MaxShift = L_bgt.get(i).get(0);
            else if (PumpCard_MinShift > L_bgt.get(i).get(0)) PumpCard_MinShift = L_bgt.get(i).get(0);

            if (L_bgt.get(i).get(0) >= 0 && L_bgt.get(previousindex).get(1) <= 0) {
                if (L_LeftDownStroke1 > (L_bgt.get(i).get(0) + L_bgt.get(previousindex).get(0)) / 2)
                    L_LeftDownStroke1 = (L_bgt.get(i).get(0) + L_bgt.get(previousindex).get(0)) / 2;
            }

            if (L_bgt.get(i).get(0) <= 0 && L_bgt.get(previousindex).get(1) >= 0) {
                if (L_LeftDownStroke2 < (L_bgt.get(i).get(0) + L_bgt.get(previousindex).get(0)) / 2) {
                    L_LeftDownStroke2 = (L_bgt.get(i).get(0) + L_bgt.get(i).get(0)) / 2;
                    //用的I TODO:check
                    //L_LeftDownStroke2 = (L_bgt.get(i).get(0) + L_bgt.get(previousindex).get(0)) / 2;
                }
            }


            int nextindex = i + 1;
            if (i == Card_Point - 1) {
                nextindex = 0;
            }
            Card_Power = Card_Power + (L_sgt.get(nextindex).get(1) + L_sgt.get(i).get(1)) * (L_sgt.get(nextindex).get(0) - L_sgt.get(i).get(0)) / 2;
            PumpCard_Power =
                    PumpCard_Power + (L_bgt.get(nextindex).get(1) + L_bgt.get(i).get(1)) * (L_bgt.get(nextindex).get(0) - L_bgt.get(i).get(0)) / 2;
            if ((L_sgt.get(nextindex).get(0) - L_sgt.get(i).get(0)) == 0)
                CardSlope.Card_Slope = 100;
            else
                CardSlope.Card_Slope = Math.abs((L_sgt.get(nextindex).get(1) - L_sgt.get(i).get(1)) / (L_sgt.get(nextindex).get(0) - L_sgt.get(i).get(0)));
            if ((L_bgt.get(nextindex).get(0) - L_bgt.get(i).get(0)) == 0)
                CardSlope.PumpCard_Slope = 100;
            else
                CardSlope.PumpCard_Slope = Math.abs(
                        (L_bgt.get(nextindex).get(1) - L_bgt.get(i).get(1)) / (L_bgt.get(nextindex).get(0) - L_bgt.get(i).get(0)));
            CardSlope.PumpCard_Shift = L_bgt.get(i).get(0);


            if (CardSlope.Card_Slope >= 100)
                CardSlope.Card_Slope = 100;
            if (CardSlope.Card_Slope <= -100)
                CardSlope.Card_Slope = 100;
            if (CardSlope.PumpCard_Slope >= 100)
                CardSlope.PumpCard_Slope = 100;
            if (CardSlope.PumpCard_Slope <= -100)
                CardSlope.PumpCard_Slope = 100;


            CardSlope_array.add(CardSlope);
        }

        Card_Power = Math.abs(Card_Power) / (60 / L_Cycle);
        PumpCard_Power = Math.abs(PumpCard_Power) / (60 / L_Cycle);


        L_Bx = 0;
        L_Rcl = 0;
        L_Rcyl = 0;
        L_Rcsl = 0;
        L_Rcql = 0;
        L_RightDownPoint = 0;
        L_RightDownLoad = 0;
        L_RightDownStroke = 0;
        L_LeftUpPoint = 0;
        L_RightUpPoint = 0;
        L_LeftUpLoad = 0;
        L_RightUpLoad = 0;
        L_LeftUpStroke = 0;
        L_RightUpStroke = 0;
        L_UpEffectiveStroke = 0;
        L_Sjcc = 0;
        L_Yxcc = 0;
        L_Ccss = 0;
        L_Llpl = 0;
        L_Lsss = 0;
        L_Gyss = 0;
        L_Cmd = 0;
        L_Gradient = 35;
        L_UpPointDivide = 0;
        l_StrokeRatio = 0;
        L_DivideNum = 3.5;
        L_DivideLoad = (PumpCard_MaxLoad - PumpCard_MinLoad) / L_DivideNum;


        for (int i = 0; i < Card_Point / 2; i++) {
            int lastindex = Card_Point - i - 1;
            if (L_bgt.get(lastindex).get(1) < (PumpCard_MinLoad + L_DivideLoad) &&
                    CardSlope_array.get(lastindex).PumpCard_Slope < L_Gradient) {
                L_RightDownLoad = L_bgt.get(lastindex).get(1);
                L_RightDownStroke = CardSlope_array.get(lastindex).PumpCard_Shift;
                L_RightDownPoint = lastindex;
            }
        }


        if (L_RightDownStroke == 0)
            L_RightDownStroke = L_LeftDownStroke;

        if ((PumpCard_MaxShift - PumpCard_MinShift) != 0) {
            l_StrokeRatio = (L_RightDownStroke - L_LeftDownStroke) * 100 / (PumpCard_MaxShift - PumpCard_MinShift);
        }

        if (false)
            if (L_Bdxs <= 0) {
                L_Bdxs = 1;
            }

        //IF L_BDXS IS NULL OR L_BDXS<=0 THEN L_BDXS=1; END IF;

        boolean p_gybz = L_Zdjg.contains("供液不足");
        if ((L_Zdjg.contains("供液正常") || p_gybz) && l_StrokeRatio > 80) {
            L_Gradient = gradient_1;
            L_DivideNum = dividenum_1;
        }

        if (p_gybz && l_StrokeRatio <= 80) {
            L_Gradient = gradient_2;
            L_DivideNum = dividenum_2;
        }
        if (p_gybz && l_StrokeRatio <= 45) {
            L_Gradient = gradient_3;
            L_DivideNum = dividenum_3;
        }
        if (p_gybz && l_StrokeRatio <= 35) {
            L_Gradient = gradient_4;
            L_DivideNum = dividenum_4;
        }
        if (p_gybz && l_StrokeRatio <= 25) {
            L_Gradient = gradient_5;
            L_DivideNum = dividenum_5;
        }
        if (p_gybz && l_StrokeRatio <= 20) {
            L_Gradient = gradient_6;
            L_DivideNum = dividenum_6;
        }
        if (p_gybz && l_StrokeRatio <= 15) {
            L_Gradient = gradient_7;
            L_DivideNum = dividenum_7;
        }
        boolean p_qyx = L_Zdjg.contains("气影响");

        if (p_qyx && l_StrokeRatio >= 35) {
            L_Gradient = gradient_8;
            L_DivideNum = dividenum_8;
        }
        if (p_qyx && l_StrokeRatio < 35) {
            L_Gradient = gradient_9;
            L_DivideNum = dividenum_9;
        }
        if (p_qyx && l_StrokeRatio < 20) {
            L_Gradient = gradient_10;
            L_DivideNum = dividenum_10;
        }

        L_DivideLoad = (PumpCard_MaxLoad - PumpCard_MinLoad) / L_DivideNum;

        L_DownPointDivide = 0;
        L_LeftDownLeak = 0;
        L_LeftUpStroke = 0;
        L_LeftDownLeak = 0;

        if (L_Bj > 57)
            L_Gradient1 = 5;
        for (int i = 0; i < Card_Point / 2; i++) {
            int lastindex = Card_Point - i - 1;
            if (L_bgt.get(lastindex).get(1) < (PumpCard_MinLoad + L_DivideLoad) &&
                    CardSlope_array.get(lastindex).PumpCard_Slope < L_Gradient) {
                L_RightDownLoad = L_bgt.get(lastindex).get(1);
                L_RightDownStroke = CardSlope_array.get(lastindex).PumpCard_Shift;
                L_RightDownPoint = lastindex;
                if (L_DownPointDivide == 0 && Math.abs(CardSlope_array.get(lastindex).PumpCard_Slope) < 25 &&
                        L_bgt.get(lastindex).get(1) < (PumpCard_MinLoad + L_DivideLoad)) {
                    L_LeftDownLeak = CardSlope_array.get(lastindex).PumpCard_Shift;
                    L_DownPointDivide = 1;
                }
            }

            if (L_UpPointDivide == 0 && Math.abs(CardSlope_array.get(i).PumpCard_Slope) < 5 &&
                    L_bgt.get(i).get(1) > ((PumpCard_MaxLoad - PumpCard_MinLoad) * 0.7 + PumpCard_MinLoad)) {
                L_LeftUpLoad = L_bgt.get(i).get(1);
                L_LeftUpStroke = CardSlope_array.get(i).PumpCard_Shift;
                L_LeftUpPoint = i;
                L_UpPointDivide = 1;
            }

            if (L_UpPointDivide == 1 && Math.abs(CardSlope_array.get(i).PumpCard_Slope) < 5 &&
                    L_bgt.get(i).get(1) > ((PumpCard_MaxLoad - PumpCard_MinLoad) * 0.8 + PumpCard_MinLoad)) {
                L_RightUpLoad = L_bgt.get(i).get(1);
                L_RightUpStroke = CardSlope_array.get(i).PumpCard_Shift;
                L_RightUpPoint = i;
            }
        }

        if (L_RightDownStroke <= 0) {
            L_RightDownStroke = L_LeftDownStroke;
        }

        if (L_Cc <= 0) {
            L_Cc = Card_MaxShift;
        }
        L_Ycc = L_RightDownStroke;
        L_Zcc = L_LeftDownStroke;

        if (L_Bj <= 95) {
            L_Llpl = L_Cycle * L_Cc * 24 * 60 * L_Bj * L_Bj * Math.PI / 4000000;
        }

        //if L_Bj<=95 then L_Llpl=L_Cycle*L_Cc*24*60*L_Bj*L_Bj*3.1415926/4000000; end if;--理论排量---------------------------------

        L_Sjcc = PumpCard_MaxShift - PumpCard_MinShift;//--实际冲程
        L_Ccss = L_Cc - L_Sjcc;//--冲程损失

        if (L_Ccss < 0)
            L_Ccss = 0;

        //if L_Ccss<0 then L_Ccss=0; end if;
        L_Lsss = 0;
        if (L_Zdjg.contains("泵工作正常") || L_Zdjg.contains("碰泵")) L_Lsss = 0;
        if (L_Zdjg.contains("游动凡尔漏失")) L_Lsss = (PumpCard_MaxShift - L_RightUpStroke) * 2;
        if (L_Zdjg.contains("固定凡尔漏失")) L_Lsss = L_Lsss + (L_LeftDownLeak - PumpCard_MinShift) * 2;
        if (L_Zdjg.contains("冲次过快")) L_Lsss = (PumpCard_MaxShift - L_RightUpStroke) * 2;
        if (L_Lsss < 0) L_Lsss = 0;

        L_Yxcc = L_RightDownStroke - L_LeftDownStroke - L_Lsss;
        if (L_Yxcc <= 0)
            L_Yxcc = 0;

        L_Gyss = L_Sjcc - L_Yxcc;
        if (L_Gyss < 0)
            L_Gyss = 0;
        if (L_Gyss == 0)
            L_Bx = 0;
        else L_Bx = L_Yxcc / L_Cc * 100;


        if (L_Bj > 0 && L_Bj <= 95) {

            if (L_Bj * L_Bj * Math.PI / 4 * 24 * 60 * L_Cycle * L_Cc * L_Bx / 100000000 >
                    0.0087 * Math.pow(2.71828, 0.0027 * L_Bs))
                L_Rcl = L_Bj * L_Bj * Math.PI / 4 * 24 * 60 * L_Cycle * L_Cc * L_Bx / 100000000 * L_Bdxs;//---0.0087*power(2.71828,0.0027*nvl(L_Bs,0));
            else
                L_Rcl = L_Bj * L_Bj * Math.PI / 4 * 24 * 60 * L_Cycle * L_Cc * L_Bx / 100000000 * L_Bdxs;

            if (L_Rcl <= 0)
                L_Rcl = 0;
            if (L_Hs <= 100) {
                L_Rcsl = L_Rcl * L_Hs / 100;
                L_Rcyl = L_Rcl - L_Rcsl;
                if (L_Ccsmd > 1 && L_Ccsmd < 1.5) {
                } else
                    L_Ccsmd = 1.05;
                if (L_Dmyybz > 0.6 && L_Dmyybz < 1.5) {
                } else
                    L_Dmyybz = 0.83;
                if (L_Bs > 0)
                    L_TheoryLoadLiquid = Math.PI / 4 * (L_Bj * L_Bj / 1000000) * L_Bs *
                            ((1 - L_Hs / 100) * L_Dmyybz + L_Hs / 100 * L_Ccsmd) * 9.8 *
                            (1 + L_Cycle * Card_MaxShift / 127);
                else
                    L_TheoryLoadLiquid = Math.PI / 4 * (L_Bj * L_Bj / 1000000) * L_PumpDepth *
                            ((1 - L_Hs / 100) * L_Dmyybz + L_Hs / 100 * L_Ccsmd) * 9.8 *
                            (1 + L_Cycle * Card_MaxShift / 127);
                if (L_Qyb >= 0)
                    L_Rcql = L_Qyb * L_Rcyl;
                Productioncoefficient = 1;
                if ((PumpCard_MaxLoad - PumpCard_MinLoad) / L_TheoryLoadLiquid < 0.8 && !zdjg.contains("喷抽") &&
                        L_Bs > 1750)
                    Productioncoefficient = (PumpCard_MaxLoad - PumpCard_MinLoad) / L_TheoryLoadLiquid;
                else
                    Productioncoefficient = 1;
                L_Rcsl = L_Ccsmd * L_Rcsl * Productioncoefficient;
                L_Rcyl = L_Dmyybz * L_Rcyl * Productioncoefficient;
                L_Rcl = L_Rcsl + L_Rcyl;
            } else {
                L_Llbj = Math.sqrt((PumpCard_MaxLoad - PumpCard_MinLoad) * 4 / (9.8 * L_PumpDepth * Math.PI)) *
                        1000;//--+power(0.019,2)
            }
        }

        if (L_Hs < 0 || L_Dmyybz < 0 || L_Ccsmd < 0 || L_Qyb < 0 || L_Bj <= 0 || L_Bj > 95) {
            L_ZdjgJc = "基本数据不全";
            L_Zdjg += L_ZdjgJc;
        }

        L_Dym = -10;//什么情况
        if (L_Dym >= 0 && L_Bj <= 95)//什么情况
        {
            if (L_Bs <= 0)
                L_Bs = L_PumpDepth;
            if (L_Hs < 0 || L_Hs > 100)
                L_Hs = 60;
            if (L_Dmyybz <= 0)
                L_Dmyybz = 0.84;
            if (L_Ccsmd <= 0)
                L_Ccsmd = 1.05;
            if (L_Bj <= 0)
                L_Bj = 38;
        } else {
            if (L_Bs <= 0)
                L_Bs = L_PumpDepth;
            if (L_Hs < 0 || L_Hs > 100)
                L_Hs = 60;
            if (L_Dmyybz <= 0)
                L_Dmyybz = 0.84;
            if (L_Ccsmd <= 0)
                L_Ccsmd = 1.05;
            if (L_Bj <= 0 || L_Bj > 95)
                L_Bj = 38;
            if ((((1 - L_Hs / 100) * L_Dmyybz + L_Hs / 100 * L_Ccsmd) * 9.8 * 0.25 * Math.PI * Math.pow(L_Bj, 2) / 1000) ==
                    0)
                L_Cmd = 0;
            else {
                L_Cmd = Math.abs(PumpCard_MinLoad * L_Yxcc / L_Sjcc) * 1000 /
                        (((1 - L_Hs / 100) * L_Dmyybz + L_Hs / 100 * L_Ccsmd) * 9.8 * 0.25 * Math.PI * Math.pow(L_Bj, 2) /
                                1000);
                L_Dym = L_Bs - L_Cmd;
            }
        }

        if (L_Gyss < PumpCard_MaxShift || L_Ccss < PumpCard_MaxShift || L_Lsss < PumpCard_MaxShift)
            PumpCard_MaxShift = L_Cc;

        double rcyl1 = L_Rcl / L_Dmyybz;
        double rcyl = L_Rcyl;
        double rcsl = L_Rcsl;
        double rcql = L_Rcql;
        double bx = L_Bx;
        double llpl = L_Llpl;
        double sjcc = L_Sjcc;
        double yxcc = L_Yxcc;
        double zcc = L_Zcc;
        double ycc = L_Ycc;
        double ccss = L_Ccss;
        double lsss = L_Lsss;
        double gyss = L_Gyss;
        double pumpdepth = L_PumpDepth;
    /* String str = "";
     str += std::to_string(rcyl1) + ";" + std::to_string(rcyl) + ";" + std::to_string(rcsl) + ";" +
            std::to_string(rcql) + ";" + std::to_string(bx) + ";" + std::to_string(llpl) + ";" + std::to_string(sjcc) +
            ";" + std::to_string(
             yxcc) + ";" + std::to_string(zcc) +
            ";" + std::to_string(ycc) + ";" + std::to_string(ccss) + ";" + std::to_string(lsss) + ";" + std::to_string(
             gyss) + ";" + std::to_string(l_StrokeRatio) + ";";*/

        List<Double> res = new ArrayList<>();
        res.add(rcyl1);
        res.add(rcyl);
        res.add(rcsl);
        res.add(rcql);
        res.add(bx);
        res.add(llpl);
        res.add(sjcc);
        res.add(yxcc);
        res.add(zcc);
        res.add(ycc);
        res.add(ccss);
        res.add(lsss);
        res.add(gyss);
        res.add(l_StrokeRatio);
        return res;
    }
}
