package com.gct.edge.zdly.dgns.algo;

import com.gct.common.util.SGTUtil;

import java.util.*;
import java.util.stream.Collectors;

/**
 * @author xusirui 2021/12/21
 */
public class CalGtSimilar {

    private Double[] CardType;

    private Integer[][][] CardGray;

    private Integer DensePointNum;

    private Double[][] DenseCard;

    private Double[][] Card;

    private Double DenseMaxshift = 0.0;
    private Integer DenseMaxshiftPoint = 0;
    private Double DenseMinshift = 1e9;
    private Integer DenseMinshiftPoint = 0;
    private Double DenseMaxLoad = 0.0;
    private Integer DenseMaxLoadPoint = 0;
    private Double DenseMinLoad = 1e9;
    private Integer DenseMinLoadPoint = 0;

    private final Integer densecard_point_num_max = 2100;
    private final Integer cardgray_width = 64;
    private final Integer cardgray_height = 32;
    private final Integer cardgray_value_default = 129;
    private final Integer cardgray_value_usage = 1;
    private static final Integer cardgray_characters_num = 48;
    private final Integer cardgray_row_block_num = 2;
    private final Integer cardgray_col_block_num = 2;
    private final Integer cardgray_nlgt_func_count = 2;
    private final Integer cardgray_block_cha_num = 6;
    private final Integer card_min_point_num = 20;

    public Double[] getCardType() {
        return CardType;
    }

    public Double[] tryCalGray(List<List<Double>> gt) {
        try {
            boolean b = calGray(gt);
            if (b) return CardType;
        } catch (Exception e) {
            System.out.println("gray error calculate.");
        }
        return null;
    }

    private boolean calGray(List<List<Double>> gt) {
        if (Objects.isNull(gt) || gt.size() < card_min_point_num) return false;

        double Gray_Typemax, Gray_Typemin;
        int Den_MaxDistance = 1000, Hui_bottom = 1000, Hui_upper = 1000, Hui_left = 1000, Hui_right = 1000;
        int Insert_Num, i = 1, j, k, L;
        if (gt.isEmpty()) return false;
        Card = SGTUtil.diagramReverse(gt);

        CardType = new Double[cardgray_characters_num];
        Insert_Num = densecard_point_num_max / gt.size();
        DensePointNum = Insert_Num * gt.size();
        DenseCard = new Double[2][];
        //DenseCard[0]、Card[0] 是位移  DenseCard[1]、Card[0]是载荷
        DenseCard[0] = new Double[DensePointNum];
        DenseCard[1] = new Double[DensePointNum];
        for (j = 0; j < gt.size(); j++) {  //todo: size

            for (i = 0; i < Insert_Num; ++i) {
                int DenseCardIndex = j * (Insert_Num) + i;
                DenseCard[0][DenseCardIndex] =
                        Card[0][j] + (Card[0][j + 1] - Card[0][j]) / (Insert_Num) * i;
                DenseCard[1][DenseCardIndex] =
                        Card[1][j] + (Card[1][j + 1] - Card[1][j]) / (Insert_Num) * i;
                if (DenseCard[0][DenseCardIndex] >= DenseMaxshift) {
                    DenseMaxshift = DenseCard[0][DenseCardIndex];
                    DenseMaxshiftPoint = DenseCardIndex;
                }
                if (DenseCard[0][DenseCardIndex] < DenseMinshift) {
                    DenseMinshift = DenseCard[0][DenseCardIndex];
                    DenseMinshiftPoint = DenseCardIndex;
                }
                if (DenseCard[1][DenseCardIndex] > DenseMaxLoad) {
                    DenseMaxLoad = DenseCard[1][DenseCardIndex];
                    DenseMaxLoadPoint = DenseCardIndex;
                }
                if (DenseCard[1][DenseCardIndex] < DenseMinLoad) {
                    DenseMinLoad = DenseCard[1][DenseCardIndex];
                    DenseMinLoadPoint = DenseCardIndex;
                }
            }
        }

        /***********Gray Cal IMG************/
        CardGray = new Integer[cardgray_nlgt_func_count][][];
        for (int l = 0; l < cardgray_nlgt_func_count; ++l) {
            CardGray[l] = new Integer[cardgray_width][];
            for (i = 0; i < cardgray_width; i++) {
                CardGray[l][i] = new Integer[cardgray_height];
                for (j = 0; j < cardgray_height; j++) {
                    CardGray[l][i][j] = cardgray_value_default;
                }
            }
        }

        int cardgray_width_value = cardgray_width - 1;
        int cardgray_height_value = cardgray_height - 1;
        double d_densecardshift = DenseMaxshift - DenseMinshift;
        if (d_densecardshift <= 0) d_densecardshift = 0.000001;
        double d_densecardload = DenseMaxLoad - DenseMinLoad;
        if (d_densecardload <= 0) d_densecardload = 0.000001;
        if (DenseMaxLoad <= 0) DenseMaxLoad = 0.000001;

        /*std::cout << "DenseMaxshift:" << DenseMaxshift << "DenseMinshift:" << DenseMinshift
                  << std::endl;
        std::cout << "DenseMinLoad:" << DenseMinLoad << "DenseMaxLoad:" << DenseMaxLoad
                  << std::endl;*/
        for (i = 0; i < DensePointNum; i++) {
            int Gray_x = (int) ((DenseCard[0][i] - DenseMinshift) / d_densecardshift *
                    cardgray_width_value);
            if (Gray_x > cardgray_width_value) Gray_x = cardgray_width_value;
            int Gray_y1 = (int) ((DenseCard[1][i] - DenseMinLoad) / d_densecardload *
                    cardgray_height_value);
            if (Gray_y1 > cardgray_height_value) Gray_y1 = cardgray_height_value;

            int Gray_y2 = (int) (DenseCard[1][i] / DenseMaxLoad * cardgray_height_value);
            if (Gray_y2 > cardgray_height_value) Gray_y2 = cardgray_height_value;

            CardGray[0][Gray_x][Gray_y1] = cardgray_value_usage;
            CardGray[1][Gray_x][Gray_y2] = cardgray_value_usage;
        }
        int block_width = cardgray_width / cardgray_col_block_num;
        int block_height = cardgray_height / cardgray_row_block_num;
        int block_area = block_width * block_height;
        for (int nlgtindex = 0; nlgtindex < cardgray_nlgt_func_count; ++nlgtindex) {

         /*   System.out.println("像素两值化图像 gt:::");
            for (i = cardgray_height - 1; i >= 0; i--) {

                for (j = 0; j < cardgray_width; j++) {
                    if (CardGray[nlgtindex][j][i] == 1)
                        System.out.printf("%2d", 11); //<<CardGray[0][j][i];
                    else System.out.printf("  ");
                }
                System.out.println();
            }*/

            for (i = 0; i < cardgray_height; i++) {
                for (j = 0; j < cardgray_width; j++) {
                    Den_MaxDistance = 1000;
                    Hui_bottom = 1000;
                    Hui_upper = 1000;
                    Hui_left = 1000;
                    Hui_right = 1000;
                    if (CardGray[nlgtindex][j][i] == cardgray_value_default) {
                        for (k = j; k < cardgray_width; k++) {
                            if (CardGray[nlgtindex][k][i] == cardgray_value_usage) {
                                Hui_right = Math.abs(k - j);
                                break;
                            }
                        }

                        for (k = i; k < cardgray_height; k++) {
                            if (CardGray[nlgtindex][j][k] == cardgray_value_usage) {
                                Hui_upper = Math.abs(k - i);
                                break;
                            }
                        }

                        for (k = 0; k <= i; k++) {
                            if (CardGray[nlgtindex][j][i - k] == cardgray_value_usage) {
                                Hui_bottom = Math.abs(k);
                                break;
                            }
                        }

                        for (k = 0; k <= j; k++) {
                            if (CardGray[nlgtindex][j - k][i] != cardgray_value_default) {
                                if (Hui_bottom == 1000 || Hui_upper == 1000 || Hui_right == 1000) {
                                    Hui_left = Math.abs(CardGray[nlgtindex][j - k][i] - k - 1);
                                } else {
                                    Hui_left = Math.abs(CardGray[nlgtindex][j - k][i] + k - 1);
                                }
                                break;
                            }
                        }

                        if (Hui_bottom <= Den_MaxDistance) Den_MaxDistance = Hui_bottom;
                        if (Hui_upper <= Den_MaxDistance) Den_MaxDistance = Hui_upper;
                        if (Hui_left <= Den_MaxDistance) Den_MaxDistance = Hui_left;
                        if (Hui_right <= Den_MaxDistance) Den_MaxDistance = Hui_right;
                        if (Hui_bottom == 1000 || Hui_upper == 1000 || Hui_left == 1000 || Hui_right == 1000) {
                            CardGray[nlgtindex][j][i] = cardgray_value_usage - Den_MaxDistance;
                        } else {
                            CardGray[nlgtindex][j][i] = cardgray_value_usage + Den_MaxDistance;
                        }


                    }
                }
            }

          /*  for (i = cardgray_height - 1; i >= 0; i--) {

                for (j = 0; j < cardgray_width; j++) {
                    if (CardGray[nlgtindex][j][i] == 1)
                        System.out.printf("\033[30;4m%3d\033[0m", CardGray[nlgtindex][j][i]);
                    else
                        System.out.printf("\033[33;4m%3d\033[0m", CardGray[nlgtindex][j][i]);
                }
                System.out.println();
            }
            System.out.println();
            System.out.println();
            System.out.println();*/


            Gray_Typemax = -10000000;
            Gray_Typemin = 10000000;

            for (int rowbolockindex = 0; rowbolockindex < cardgray_col_block_num; ++rowbolockindex) {
                for (int colbolockindex = 0; colbolockindex < cardgray_row_block_num; ++colbolockindex) {
                    int cardgray_block_x_start = block_width * rowbolockindex;
                    int cardgray_block_x_end = block_width * (rowbolockindex + 1);
                    int cardgray_block_y_start = block_height * colbolockindex;
                    int cardgray_block_y_end = block_height * (colbolockindex + 1);

                    Map<Integer, Integer> grayvalue_counter = new HashMap<>();
                    for (int x = cardgray_block_x_start; x < cardgray_block_x_end; ++x) {
                        for (int y = cardgray_block_y_start; y < cardgray_block_y_end; ++y) {
                            int temp = CardGray[nlgtindex][x][y];

                            if (grayvalue_counter.containsKey(temp)) {
                                Integer val = grayvalue_counter.get(temp);
                                grayvalue_counter.put(temp, val + 1);
                            } else
                                grayvalue_counter.put(temp, 1);
                        }
                    }
                    Map<Integer, Double> grayvalue_probability = new HashMap<>();
                    List<Double> cha_block = new ArrayList<>();

                    double cha0 = 0;
                    for (Map.Entry<Integer, Integer> entry : grayvalue_counter.entrySet()) {
                        double temp = entry.getValue() * 1.0 / block_area;
                        grayvalue_probability.put(entry.getKey(), temp);
                        cha0 += entry.getKey() * temp;
                    }

                    cha_block.add(cha0);
                    double cha1 = 0, cha2 = 0, cha3 = 0, cha4 = 0, cha5 = 0;
                    for (Map.Entry<Integer, Double> entry : grayvalue_probability.entrySet()) {
                        cha1 += Math.pow(entry.getKey() - cha0, 2) *
                                entry.getValue();
                        cha2 += Math.pow(entry.getKey() - cha0, 3) *
                                entry.getValue();
                        cha3 += Math.pow(entry.getKey() - cha0, 4) *
                                entry.getValue();
                        cha4 += Math.pow(entry.getValue(), 2);
                        cha5 += (1 - entry.getValue()) *
                                Math.log10(1 - entry.getValue());
                    }

                    cha2 = cha2 / Math.pow(cha1, 3 / 2.0);
                    cha3 = cha3 / Math.pow(cha1, 2);
                    cha_block.add(cha1);
                    cha_block.add(cha2);
                    cha_block.add(cha3);
                    cha_block.add(cha4);
                    cha_block.add(cha5);

                    int cha_start_point_index = nlgtindex * cardgray_col_block_num * cardgray_row_block_num;
                    cha_start_point_index += rowbolockindex * cardgray_col_block_num + colbolockindex;
                    cha_start_point_index *= cardgray_block_cha_num;
                    for (int cha_l = 0; cha_l < cha_block.size(); ++cha_l) {
                        if (cha_block.get(cha_l) > Gray_Typemax) Gray_Typemax = cha_block.get(cha_l);
                        if (cha_block.get(cha_l) < Gray_Typemin) Gray_Typemin = cha_block.get(cha_l);
                        CardType[cha_start_point_index + cha_l] = cha_block.get(cha_l);
                    }

                }
            }
            for (int chacc_l = nlgtindex * cardgray_row_block_num * cardgray_col_block_num * cardgray_block_cha_num;
                 chacc_l < (nlgtindex + 1) * cardgray_row_block_num * cardgray_col_block_num *
                         cardgray_block_cha_num; ++chacc_l) {
                CardType[chacc_l] =
                        (CardType[chacc_l] - Gray_Typemin) / (Gray_Typemax - Gray_Typemin);
            }
        }
        return true;
    }


    public static Double compareCharacters(List<Double> s_cha, List<Double> k_cha, int method) {
        if (s_cha.isEmpty() || k_cha.isEmpty()) return 0.0;
        double l_res1 = 0.0;
        double Com_max = -200.00;
        double Com_min = 200.01;
        double Mid_Value1 = 0;
        double Mid_Value2 = 0;
        double L_DLT1 = 0;
        double L_DLT2 = 0;
        double l_res2 = 0;
        Double[] d_cha = new Double[cardgray_characters_num];
        switch (method) {
            case 23: {
                Com_max = -200.00;
                Com_min = 200.01;
                Mid_Value1 = 0;
                Mid_Value2 = 0;

                for (int i = 0; i <= method; i++) {

                    d_cha[i] = Math.abs(s_cha.get(i) - k_cha.get(i));
                    if (d_cha[i] >= Com_max) Com_max = d_cha[i];
                    if (d_cha[i] <= Com_min) Com_min = d_cha[i];
                }
                if (Com_max == Com_min) l_res1 = 1;
                else {
                    for (int i = 0; i <= method; i++) {
                        Mid_Value1 = Mid_Value1 + 1 / (d_cha[i] + Com_max / 2);
                        Mid_Value2 = Mid_Value2 + d_cha[i];
                    }
                    L_DLT1 = 1.0 / (1 + Mid_Value2 / (method + 1));
                    l_res1 = L_DLT1;
                }
                Mid_Value1 = 0;
                Mid_Value2 = 0;
                Com_max = -200.00;
                Com_min = 200.01;

                for (int i = method + 1; i < cardgray_characters_num; i++) {
                    d_cha[i] = Math.abs(s_cha.get(i) - k_cha.get(i));
                    if (d_cha[i] >= Com_max) Com_max = d_cha[i];
                    if (d_cha[i] <= Com_min) Com_min = d_cha[i];
                }
                if (Com_max == Com_min) l_res2 = 1;
                else {
                    for (int i = method + 1; i < cardgray_characters_num; i++) {
                        Mid_Value1 = Mid_Value1 + 1 / (d_cha[i] + Com_max / 2);
                        Mid_Value2 = Mid_Value2 + d_cha[i];
                    }
                    L_DLT2 = 1 / (1 + Mid_Value2 / (cardgray_characters_num - 1 - method));
                    l_res2 = L_DLT2;
                }
                l_res1 = l_res1 * 0.8 + l_res2 * 0.2;
                return l_res1;
            }
        }
        return l_res1;
    }

    public static Double cal(List<List<Double>> gt1, List<List<Double>> gt2) {
        CalGtSimilar gtSimilar1 = new CalGtSimilar();
        CalGtSimilar gtSimilar2 = new CalGtSimilar();
        try {
            boolean res1 = gtSimilar1.calGray(gt1);
            boolean res2 = gtSimilar2.calGray(gt2);
            if (res1 && res2) {
                return compareCharacters(Arrays.asList(gtSimilar1.CardType), Arrays.asList(gtSimilar2.CardType), 23);
            }
            return -1.0;
        } catch (Exception e) {
            return -2.0;
        }
    }

    public static Double cal2(List<Double> stdFuture, List<List<Double>> sgt) {
        CalGtSimilar gtSimilar2 = new CalGtSimilar();
        try {
            boolean res2 = gtSimilar2.calGray(sgt);
            if (res2) {
                return compareCharacters(stdFuture, Arrays.asList(gtSimilar2.CardType), 23);
            }
            return -1.0;
        } catch (Exception e) {
            return -2.0;
        }
    }

    public static List<Double> encodeToList(String futureStr){
        if (futureStr.isEmpty())return new ArrayList<>();
        return Arrays.stream(futureStr.split(",")).map(Double::valueOf).collect(Collectors.toList());
    }

    public static String encodeToString(Double[] future){
        StringBuilder sb = new StringBuilder();
        for (Double v : future) {
            sb.append(v).append(",");
        }
        sb.deleteCharAt(sb.length()-1);
        return sb.toString();
    }

}
