package com.gct.edge.zdly.dgns.core;

import com.alibaba.fastjson.JSONObject;
import com.gct.common.util.SGTUtil;
import com.gct.edge.entity.CalculateInputData;
import com.gct.edge.entity.DgnsGtcvrresult;
import com.gct.edge.service.abst.DgnsGtcvrresultService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;
import java.util.UUID;


/**
 * @author xusirui 2021/6/30
 */
@Component
@Slf4j
public class GenerateResult implements DiagnosePart {

    @Autowired
    DgnsGtcvrresultService dgnsGtcvrresultService;

    @Override
    public void accept(DiagnoseVisitor diagnoseVisitor) {
        CalculateInputData calculateInputData = diagnoseVisitor.calculateInputData;
        DgnsGtcvrresult cvResult = diagnoseVisitor.cvResult;

        cvResult.setId(UUID.randomUUID().toString())
                .setWellname(calculateInputData.getWellId())
                .setSgt(SGTUtil.encodeToString(calculateInputData.getSgt()))
                .setProcessparam(generateProcessParam(diagnoseVisitor))
                .setCreatetime(LocalDateTime.now().format(DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss")))
                .setIsexpected(1)
                .setIsproblem("0");
        dgnsGtcvrresultService.save(cvResult);
        log.info("功图诊断结果: " + cvResult.getResult2());
    }

    private String generateProcessParam(DiagnoseVisitor diagnoseVisitor) {
        JSONObject obj = new JSONObject();
        obj.put("sgt_recivetime", diagnoseVisitor.gtbaseparam.getRecivetime());
        return obj.toJSONString();
    }

}
