package com.gct.edge.zdly.dgns.core;

import com.gct.common.util.SGTUtil;
import com.gct.edge.zdly.dgns.algo.DiagramValidate;
import com.gct.edge.entity.CalculateInputData;
import com.gct.edge.entity.DgnsGtbaseparam;
import com.gct.edge.entity.DgnsGtcvrresult;
import com.gct.edge.service.abst.DgnsGtbaseparamService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import java.time.LocalDateTime;
import java.time.format.DateTimeFormatter;

/**
 * @author xusirui 2021/6/29
 */
@Component
public class GtAnalysis implements DiagnosePart {

    @Autowired
    DgnsGtbaseparamService dgnsGtbaseparamService;

    @Override
    public void accept(DiagnoseVisitor diagnoseVisitor) {
        CalculateInputData inputData = diagnoseVisitor.calculateInputData;
        DateTimeFormatter df = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm:ss");
        DgnsGtbaseparam dgnsGtbaseparam = new DgnsGtbaseparam();
        dgnsGtbaseparam.setSPre(inputData.getStroke().toString());
        dgnsGtbaseparam.setN(inputData.getFrequency().toString());
        dgnsGtbaseparam.setRecivetime(inputData.getProdDate().format(df));
        dgnsGtbaseparam.setWellname(inputData.getWellId());
        dgnsGtbaseparam.setSgt(SGTUtil.encodeToString(inputData.getSgt()));
        dgnsGtbaseparam.setSgtpointnum(inputData.getSgt().length);
        dgnsGtbaseparam.setCreatetime(LocalDateTime.now().format(df));
        if(inputData.getSgt()!=null&&!inputData.getSgt().equals("")){
            new DiagramValidate().analysisParam(inputData.getSgt(), dgnsGtbaseparam);
        }else {
            dgnsGtbaseparam.setSgt("0,0");
            dgnsGtbaseparam.setIslegal(0);
            dgnsGtbaseparam.setRemark("功图为空");
        }

        dgnsGtbaseparamService.save(dgnsGtbaseparam);
        if (dgnsGtbaseparam.getIslegal()==0){
            DgnsGtcvrresult result = diagnoseVisitor.cvResult = new DgnsGtcvrresult();
            result.setResult2(dgnsGtbaseparam.getRemark());
        }
        diagnoseVisitor.gtbaseparam = dgnsGtbaseparam;
    }
}
