package com.gct.edge.zdly.dgns.decisiontree.DataLoadTemplates;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.gct.common.util.StringUtil;
import com.gct.edge.zdly.dgns.decisiontree.DependentDataConstructor;
import static com.gct.edge.zdly.dgns.decisiontree.DependentDataFieldEnum.*;
import com.gct.edge.entity.AoidConfigData;
import com.gct.edge.service.abst.AoidConfigDataService;
import lombok.extern.slf4j.Slf4j;
import org.springframework.beans.factory.annotation.Autowired;

import java.util.Map;


@DependentDataConstructor.DependentDataLoad(Name = "GD")
@Slf4j
public class GDSimilarGtAlgorithmDataLoad implements DependentDataConstructor.IDependentDataLoad {

    @Autowired
    AoidConfigDataService aoidConfigDataService;

    @Override
    public void loadData(Map<String, Object> gdMap) {
        String wellName = gdMap.get(JH.getEnDec()).toString();
        AoidConfigData aoidConfigData = aoidConfigDataService.getOne(new QueryWrapper<AoidConfigData>().eq("jh", wellName));
        if (aoidConfigData != null) {
            gdMap.put(DYM.getEnDec(), Double.parseDouble(aoidConfigData.getDym()));
            gdMap.put(BS.getEnDec(), Double.parseDouble(aoidConfigData.getBs()));
            gdMap.put(BZDYM.getEnDec(), Double.parseDouble(aoidConfigData.getDym()));
            gdMap.put(BZBS.getEnDec(), Double.parseDouble(aoidConfigData.getBs()));
            if (StringUtil.isBlankOrEmpty(aoidConfigData.getDym()) || StringUtil.isBlankOrEmpty(aoidConfigData.getBs())) {
                gdMap.put(CMD.getEnDec(), null);
                gdMap.put(BZCMD.getEnDec(), null);
            } else {
                Double bs = Double.parseDouble(aoidConfigData.getBs());
                Double dym = Double.parseDouble(aoidConfigData.getDym());
                gdMap.put(CMD.getEnDec(), bs-dym);
                gdMap.put(BZCMD.getEnDec(), bs-dym);
            }
            gdMap.put(BJ.getEnDec(), aoidConfigData.getBj());
            gdMap.put(BZBJ.getEnDec(), aoidConfigData.getBj());
        } else {
            gdMap.put(DYM.getEnDec(), null);
            gdMap.put(BZDYM.getEnDec(), null);
            gdMap.put(BS.getEnDec(), null);
            gdMap.put(BZBS.getEnDec(), null);
            gdMap.put(CMD.getEnDec(), null);
            gdMap.put(BZCMD.getEnDec(), null);
            gdMap.put(BJ.getEnDec(), null);
            gdMap.put(BZBJ.getEnDec(), null);
        }
    }
}
