package com.gct.edge.zdly.dgns.decisiontree.DataLoadTemplates;

import com.gct.common.util.SGTUtil;
import com.gct.edge.zdly.dgns.decisiontree.DependentDataConstructor;
import static com.gct.edge.zdly.dgns.decisiontree.DependentDataFieldEnum.*;

import java.util.Map;

@DependentDataConstructor.DependentDataLoad(Name = "SGXP")
public class SGXPJudgeAlgorithmDataLoad implements DependentDataConstructor.IDependentDataLoad {

    @Override
    public void loadData(Map<String, Object> gdMap) {
        //todo  :1.4.9 use algorithm to deal cc get JcD
        Double intersectPos = -1.0;
        String sgtStr = gdMap.get("sgt").toString();
        try{
            Double[][] gt = SGTUtil.encodeToDoubleArray(sgtStr);
            int protectPointNum = (int) (gt.length / 2 * 0.1);
            for (int i = protectPointNum; i <= gt.length / 2-protectPointNum; i++) {
                for (int j = gt.length - 1 - 1 - protectPointNum; j >= gt.length / 2 + protectPointNum; j--) {
                    if (sideIntersectSide(gt[i][0], gt[i][1], gt[i + 1][0], gt[i + 1][1], gt[j][0], gt[j][1], gt[j + 1][0], gt[j + 1][1])) {
                        intersectPos = gt[i][0];
                    }
                }
            }
        }catch (Exception ignore){}
        gdMap.put(JCD.getEnDec(), intersectPos);
    }

    private static boolean lineIntersectSide(double aX, double aY, double bX, double bY, double cX, double cY, double dX, double dY) {
        double fC = (cY - aY) * (aX - bX) - (cX - aX) * (aY - bY);
        double fD = (dY - aY) * (aX - bX) - (dX - aX) * (aY - bY);
        return fC * fD < 0;
    }


    private static boolean sideIntersectSide(double aX, double aY, double bX, double bY, double cX, double cY, double dX, double dY) {
        if (!lineIntersectSide(aX, aY, bX, bY, cX, cY, dX, dY)) return false;
        if (!lineIntersectSide(cX, cY, dX, dY, aX, aY, bX, bY)) return false;
        return true;
    }

}
