package com.gct.edge.zdly.dgns.decisiontree.DataLoadTemplates;


import com.gct.common.util.SGTUtil;
import com.gct.edge.entity.DgnsGtbaseparam;
import com.gct.edge.service.abst.DgnsGtbaseparamService;
import org.springframework.beans.factory.annotation.Autowired;
import com.gct.edge.zdly.dgns.decisiontree.DependentDataConstructor;
import static com.gct.edge.zdly.dgns.decisiontree.DependentDataFieldEnum.*;
import java.util.Map;



/**
 * class name: SampleDataLoad
 * <p>
 * 用于扩展 DependentDataConstructor 加载的 类
 * 此类需实现 IDependentDataLoad 接口 并仿照下面的进行编辑
 * </p>
 *
 * @author lloyd
 * @version 1.0
 * @since 2021/1/25 下午10:02
 */
@DependentDataConstructor.DependentDataLoad(Name = "Sample")
public class SampleDataLoad implements DependentDataConstructor.IDependentDataLoad {

    @Autowired
    DgnsGtbaseparamService dgnsGtbaseparamService;

    @Override
    public void loadData(Map<String, Object> gdMap) {
        gdMap.put(LOG.getEnDec(), "");
        DgnsGtbaseparam curGt = (DgnsGtbaseparam) gdMap.get("dgnsGtbaseparam");
        gdMap.put(YXCC.getEnDec(), curGt.getSEffect());
        gdMap.put(ZDZH.getEnDec(), curGt.getLMax());
        gdMap.put(ZHC.getEnDec(), curGt.getL());
        gdMap.put(ZXZH.getEnDec(), curGt.getLMin());
        gdMap.put(MJ.getEnDec(), curGt.getArea());
        gdMap.put(DYXXZHGD.getEnDec(), curGt.getLFistdownturnpoint());
        gdMap.put(CC.getEnDec(), curGt.getS());
        gdMap.put(ZDCC.getEnDec(), curGt.getSMax());
        gdMap.put(CCi.getEnDec(), curGt.getN());
        DgnsGtbaseparam standardGt = null;

        if (gdMap.get(BZSJ.getEnDec())!=null){
            standardGt =  dgnsGtbaseparamService.getByWellIdAndProdDate(
                    gdMap.get(JH.getEnDec()).toString(), gdMap.get(BZSJ.getEnDec()).toString());
        }

        if (standardGt != null) {
            gdMap.put(BZGT.getEnDec(), SGTUtil.encodeToUseList(standardGt.getSgt()));
            gdMap.put(BZSJ.getEnDec(), standardGt.getRecivetime());
            gdMap.put(BZZDZH.getEnDec(), standardGt.getLMax());
            gdMap.put(BZZHC.getEnDec(), standardGt.getL());
            gdMap.put(BZMJ.getEnDec(), standardGt.getArea());
            gdMap.put(BZZHZX.getEnDec(), standardGt.getLMid());
            gdMap.put(BZZXZH.getEnDec(), standardGt.getLMin());
            gdMap.put(BZDYXXZHGD.getEnDec(), standardGt.getLFistdownturnpoint());
            gdMap.put(BZCC.getEnDec(), standardGt.getS());
            gdMap.put(BZYXCC.getEnDec(), standardGt.getSEffect());
            gdMap.put(BZCCi.getEnDec(), standardGt.getN());

        } else {
            gdMap.put(BZGT.getEnDec(), null);
            gdMap.put(BZSJ.getEnDec(), null);
            gdMap.put(BZZDZH.getEnDec(), null);
            gdMap.put(BZZHC.getEnDec(), null);
            gdMap.put(BZMJ.getEnDec(), null);
            gdMap.put(BZZHZX.getEnDec(), null);
            gdMap.put(BZZXZH.getEnDec(), null);
            gdMap.put(BZDYXXZHGD.getEnDec(), null);
            gdMap.put(BZCC.getEnDec(), null);
            gdMap.put(BZCCi.getEnDec(), null);
        }

    }
}
