package com.gct.edge.zdly.dgns.decisiontree;

import lombok.Data;
import lombok.EqualsAndHashCode;
import lombok.experimental.Accessors;

import java.util.List;

/**
 * class name: DecisionTree
 *
 * @author lloyd
 * @version 1.0
 * @since 2021/1/23 下午2:54
 */
@Data
@Accessors(chain = true)
@EqualsAndHashCode(callSuper = false)
public class DecisionTree extends AbstractDecisionUnit {

    private DecisionTree leftNode;

    private DecisionTree rightNode;

    private boolean logNextNote;

    public DecisionTree getNextNode(boolean isLeft) {
        logNextNote = isLeft;
        return isLeft ? leftNode : rightNode;
    }

    private String finalOutContent;

    /*
    对于该单元执行后的 一些系统描述 便于查错
    TODO:tree执行中的可读性log生成
     */
    private List<String> executeLog;

    public boolean ifNeedExecute() {
        return exeCalTemps != null && exeCalTemps.length > 0;
    }

    public boolean hasChild() {
        return leftNode != null || rightNode != null;
    }
}
