package com.gct.edge.zdly.dgns.decisiontree;

/**
 * enum name: DependentDataFieldEnum
 *
 * @author lloyd
 * @version 1.0
 * @since 2021/1/25 下午9:34
 */
public enum DependentDataFieldEnum {
    DYM(1, "动液面","DYM", "GD"),
    BS(2,"泵深","BS", "GD"),
    JH(3,"井号","JH", "null"),
    XSD(4,"相似度","XSD", "Base"),
    YXCC(5,"有效冲程","YXCC","Sample"),
    ZDZH(6,"最大载荷","ZDZH","Sample"),
    BZZDZH(7,"标准功图最大载荷","BZZDZH","Sample"),
    ZHC(8,"载荷差","ZHC","Sample"),
    BZZHC(9,"标准功图载荷差","BZZHC","Sample"),
    ZXZH(10,"最小载荷","ZXZH","Sample"),
    MJ(11,"功图面积","MJ","Sample"),
    BZMJ(12,"标准功图面积","BZMJ","Sample"),
    BZZHZX(13,"标准载荷中线","BZZHZX","Sample"),
    BZZXZH(14,"标准最小载荷","BZZXZH","Sample"),
    DYXXZHGD(15,"第一下行载荷拐点","DYXXZHGD","Sample"),
    BZDYXXZHGD(16,"标准第一下行载荷拐点","BZDYXXZHGD","Sample"),
    CC(17,"冲程","CC","Sample"),
    ZDCC(18,"最大冲程","ZDCC","Sample"),
    HSL(19,"含水率","HSL","SYTS"),
    BZHSL(20,"标准含水率","BZHSL","SYTS"),
    BF(21,"波峰","BF","ZDCS"),
    BG(22,"波谷","BG","ZDCS"),
    PJZF(23,"平均振幅","PJZF","ZDCS"),
    CZJLSD(24,"波峰到波谷的垂直距离散度","CZJLSD","ZDCS"),
    SBFKTCMJ(25,"上部分块的突出面积","SBFKTCMJ","FELS"),
    XBFKTCMJ(26,"下部分块的突出面积","XBFKTCMJ","FELS"),
    SXPJZH(27,"上行平均载荷","SXPJZH","FELS"),
    BZSXPJZH(28,"标准上行平均载荷","BZSXPJZH","FELS"),
    XXPJZH(29,"下行平均载荷","XXPJZH","FELS"),
    BZXXPJZH(30,"标准下行平均载荷","BZXXPJZH","FELS"),
    SXDDD(31,"凸包算法计算功图的凸壳上行段顶点","SXDDD","FELS"),
    XXDDD(32,"凸包算法计算功图的凸壳下行段顶点","XXDDD","FELS"),
    JCD(33,"交叉点","JCD","SGXP"),
    //接下来的数据用于在前端显示,在算法加载FeignServer数据时一并加载
    LOG(34,"诊断依据","LOG","Sample"),
    BZBS(35,"标准泵深","BZBS","GD"),
    BJ(36,"泵径","BJ","GD"),
    BZBJ(37,"标准泵径","BZBJ","GD"),
    BZCC(38,"标准冲程","BZCC","Sample"),
    CCi(39,"冲次","CCi","Sample"),
    BZCCi(40,"标准冲次","BZCCi","Sample"),
    RCYe(41,"日产液","RCYe","SYTS"),
    BZRCYe(42,"标准日产液","BZRCYe","SYTS"),
    RCY(43,"日产油","RCY","SYTS"),
    BZRCY(44,"标准日产油","BZRCY","SYTS"),
    BZDYM(45,"标准动液面","BZDYM","GD"),
    CMD(46,"沉没度","CMD","GD"),
    BZCMD(47,"标准沉没度","BZCMD","GD"),
    BZGT(48,"标准功图","BZGT","null"),
    BZSJ(49,"标准时间","BZSJ","null"),
    YCZDJG(50,"一次诊断结果","YCZDJG","Base"),
    RCQ(51,"日产气","RCQ","SYTS"),
    BZYXCC(52,"标准功图有效冲程","BZYXCC","Sample"),
    BZGK(53,"标准工况","BZGK","Base"),
    SYFELSJC(54,"适用凡尔漏失检测","SYFELSJC","SYFELSJC");

    private final int typeID;
    private final String dec;
    private final String enDec;
    private final String temp;

    DependentDataFieldEnum(int i, String dec, String enDec, String temp) {
        typeID = i;
        this.dec = dec;
        this.enDec = enDec;
        this.temp = temp;
    }

    public String getDec() {
        return dec;
    }

    public int getTypeID() {
        return typeID;
    }

    public String getEnDec() {
        return enDec;
    }

    public String getTemp() {
        return temp;
    }
}
