package com.gct.edge.zdly.dgns.decisiontree.MataComputeTemplates;

import com.gct.edge.zdly.dgns.decisiontree.ComputeTemplateProxyFactory;
import javax.validation.constraints.NotNull;
import org.junit.jupiter.api.extension.ParameterResolutionException;
import javax.naming.OperationNotSupportedException;


/**
 * class name: DivisionComputeTemplate
 *
 * @author lloyd
 * @version 1.0
 * @since 2021/1/23 下午5:13
 */
@ComputeTemplateProxyFactory.ComputeTemplate(name = "÷",describe = "除法运算模板(多参)")
public class DivisionComputeTemplate implements ComputeTemplateProxyFactory.IComputeTemplate {
    @Override
    public Object[] invokeCompute(@NotNull Object[] args) throws NumberFormatException, ParameterResolutionException, OperationNotSupportedException {
        if (args.length < 2) throw new ParameterResolutionException("Division less than 2 param");
        if (Double.parseDouble(args[1].toString()) == 0)
            throw new OperationNotSupportedException("Division 从第二个开始的参数为除数，不能为0");
        double a = Double.parseDouble(args[0].toString()) / Double.parseDouble(args[1].toString());
        for (int i = 2; i < args.length; i++) {
            double b = Double.parseDouble(args[i].toString());
            if (b == 0) throw new OperationNotSupportedException("Division 从第二个开始的参数为除数，不能为0");
            a = a / b;
        }
        return new Object[]{a};
    }
}
