package com.gct.edge.zdly.dgns.decisiontree.MataComputeTemplates;

import com.gct.edge.zdly.dgns.decisiontree.ComputeTemplateProxyFactory;
import org.junit.jupiter.api.extension.ParameterResolutionException;

import javax.validation.constraints.NotNull;

/**
 * class name: SubtractComputeTemplate
 *
 * @author lloyd
 * @version 1.0
 * @since 2021/1/23 下午4:58
 */
@ComputeTemplateProxyFactory.ComputeTemplate(name = "-",describe = "减法运算模板(多参)")
public class SubtractComputeTemplate implements ComputeTemplateProxyFactory.IComputeTemplate {
    @Override
    public Object[] invokeCompute(@NotNull Object[] args) throws NumberFormatException{

        if(args.length<2) throw new ParameterResolutionException("less than 2 param");

        double a=Double.parseDouble(args[0].toString()) -Double.parseDouble(args[1].toString());
        for (int i = 2; i < args.length; i++) {
            a-=Double.parseDouble(args[i].toString());
        }

        return new Object[]{a};
    }
}
