package com.gct.edge.zdly.dgns.thriftclient;

import lombok.Data;
import lombok.experimental.Accessors;
import org.springframework.boot.context.properties.ConfigurationProperties;
import org.springframework.validation.annotation.Validated;

/**
 * ConfigurationProperties for thrift clients and connect remote provider with it
 *
 * @author lloyd
 * @version 1.0
 * @since 2021.1.21
 */
@Accessors(chain = true)
@ConfigurationProperties(prefix = "gct.thrift.provider")
@Validated
@Data
public class ThriftClientProperties {

    private int port;
    private String host;
    /*
     ms
     */
    private int timeout;
    private String key;
}
