package com.gct.edge.zdly.dgns.thriftclient;

import org.apache.commons.pool2.PooledObjectFactory;
import org.apache.commons.pool2.impl.AbandonedConfig;
import org.apache.commons.pool2.impl.GenericObjectPool;
import org.apache.commons.pool2.impl.GenericObjectPoolConfig;
import org.apache.thrift.protocol.TBinaryProtocol;
import org.apache.thrift.protocol.TProtocol;
import org.apache.thrift.transport.TTransport;

/**
 * @author lloyd
 * @version 1.0
 * @since 2021/1/22 下午2:14
 */
public class ThriftSocketClientPool extends GenericObjectPool<TTransport> {

    public ThriftSocketClientPool(PooledObjectFactory<TTransport> factory) {
        super(factory);
    }

    public ThriftSocketClientPool(PooledObjectFactory<TTransport> factory, GenericObjectPoolConfig<TTransport> config) {
        super(factory, config);
    }

    public ThriftSocketClientPool(PooledObjectFactory<TTransport> factory, GenericObjectPoolConfig<TTransport> config, AbandonedConfig abandonedConfig) {
        super(factory, config, abandonedConfig);
    }

    /**
     * getThriftClient
     *
     * @return com.gct.subsample.thriftclient.gtcvrService.Client
     * @throws Exception reference method need to collect the exception
     */
    public gtcvrService.Client getThriftClient() throws Exception {
        TTransport tTransport = this.borrowObject();
        TProtocol tProtocol = new TBinaryProtocol(tTransport);
        return new gtcvrService.Client(tProtocol);
    }

    /**
     * 回收
     * releaseThriftClient
     */
    public void releaseThriftClient(gtcvrService.Client client) {
        TTransport tTransport = client.getInputProtocol().getTransport();
        tTransport.close();
         //TTransport tTransport = client.getOutputProtocol().getTransport();
        //因为我们声明的时候是new DebugService.Client(tProtocol)，这里两个protocol是一样的，选一个就可
        this.returnObject(tTransport);
    }
}
