package com.gct.etl;

import java.util.List;

/**
 * dec:
 * <p>
 * ModbusDataBody
 * 读取安控rtu功图等数据的包装
 * </p>
 *
 * @author lloyd
 * @version 1.0.1
 * @since 2024/4/12 下午12:22
 */
public class ModbusDataBody {
    public List<List<Double>> card;
    public Double n;
    public Double s;
    /**
     * 生产时间，功图的生成时间 eg：2024-04-25 15:54:03
     */
    public String prodTime;
    public Integer pointNum;

    @Override
    public String toString() {
        StringBuilder str = new StringBuilder().append("n:->").append(n).append('\n').append("s:->").append(s).append('\n')
                .append("card(size:").append(card.size()).append(")->[");

        for (int index = 0; index < card.size(); index++) {
            List<Double> i = card.get(index);
            str.append('[').append(i.get(0)).append(',').append(i.get(1)).append(']');
            if (index < card.size() - 1) str.append(',');
        }
        str.append("]\n");

        str.append("point number:->").append(pointNum).append('\n');
        str.append("prod time:->").append(prodTime).append('\n');
        return str.toString();
    }
}
