package com.gct.etl.loader;

import com.gct.etl.ModbusReadConfig;

import java.util.HashMap;
import java.util.Map;
import java.util.Objects;

/**
 * dec:
 * <p>
 * DefaultConfigLoader
 * </p>
 *
 * @author lloyd
 * @version 1.0.1
 * @since 2024/4/12 下午1:12
 */
public class DefaultMultiConfigLoader implements MultiModbusConfigLoader {
    private Map<Integer, ModbusReadConfig> cache = new HashMap<>();

    public DefaultMultiConfigLoader() {
        ModbusReadConfig.SerialConfig serial = new ModbusReadConfig.SerialConfig();
        serial.serialName="ttyAMA3";
        for (int i = 1; i < 10; i++) cache.put(i, alterStationId(i, new ModbusReadConfig().setSerial(serial)));
    }

    @Override
    public ModbusReadConfig loadById(int id) {
        return cache.get(id);
    }

    private ModbusReadConfig alterStationId(int id, ModbusReadConfig reg) {
        if (Objects.isNull(reg)) return null;
        if (Objects.isNull(reg.offsetRegs) || reg.offsetRegs.isEmpty()) return reg;
        for (ModbusReadConfig.Section i : reg.offsetRegs) i.stationId = id;
        if (Objects.isNull(reg.payloadRegs) || reg.payloadRegs.isEmpty()) return reg;
        for (ModbusReadConfig.Section i : reg.payloadRegs) i.stationId = id;
        if (Objects.isNull(reg.nReg)) return reg;
        reg.nReg.stationId = id;
        if (Objects.isNull(reg.sReg)) return reg;
        reg.sReg.stationId = id;
        return reg;
    }
}
